function [Com_needed_min, UE_comneed_min, Valid, DLRB_needed_min] = minpower1BS_w_limComRB_func(UE_List,UE_XDLrate,I_BS)
%will still return a invalid ai & bi if Valid = 0
%make sure b_i_DLstream < DL_avalRB before use this function
N_BS = 1;
N_UE = size(UE_XDLrate,1);
if N_UE~= size(UE_List,1)
   warning('input size is not right: N_UE is not matched'); 
end

global Comp_fullW;
global Ca;
global ca;
global DL_fullW;
global fullRB;
global DL_avalRB;

%UE_ListAssoAB = zeros(N_UE, 1); %1: Asso, 2:a_i(allocated com) 3:b_i(allocated DLRB)
%Resouce_needed = zeros(N_BS, 2); %1: total a_i(allocated com) 2:total b_i(allocated DLRB) 
UE_comneed_min = zeros(N_UE,1);
DLRB_needed_min = zeros(N_UE,1);

Valid = 1;
   
ibs = I_BS;
   for bs = 1:N_BS
        aflag = ones(N_UE,1);
        Idx_ue = find(aflag);
        temp_UE_List = UE_List;
        temp_UErate = UE_XDLrate;
        TN_UE = size(temp_UE_List,1);
        if TN_UE ~= N_UE
           warning('TN_UE ~= N_UE');
           pause;
        end        
        gan = temp_UE_List(:,7)./temp_UErate(:,ibs)./temp_UE_List(:,8);
        sig = gan.*temp_UE_List(:,6)./temp_UE_List(:,8);
        b_i_DLstream = sum(  ceil(temp_UE_List(:,9)./temp_UErate(:,ibs)), 1  );
        
        if b_i_DLstream >= DL_avalRB-TN_UE || DL_avalRB-TN_UE-b_i_DLstream-sum(gan,1) <= 0
            Valid = 0;
            UE_comneed_min = 0;
            Com_needed_min=0;
            break;
        end

          %b_i_DLstream
          Q_t = sum(sqrt(sig),1)/(DL_avalRB-TN_UE-b_i_DLstream-sum(gan,1));
          y_i = sqrt(temp_UE_List(:,6))./temp_UE_List(:,8)+sqrt(gan./temp_UE_List(:,8)).*Q_t;
          
          if Q_t <= 0 && ~isempty( temp_UE_List)
             warning('Q_t less than or equals 0');
             disp(['Q_t = ' num2str(Q_t)]);
             pause;
          end
          
          a_i = ceil(y_i.*sqrt(temp_UE_List(:,6)));
          b_i = ceil(y_i.*sqrt(gan.*temp_UE_List(:,8))./Q_t);
                 
          a_i = a_i';
          b_i = b_i'; 
          if  sum(b_i,2) + b_i_DLstream > DL_avalRB
             warning('downlink resource block exceed maximum');
             pause;
          elseif abs(sum(b_i,2) + b_i_DLstream - DL_avalRB) > TN_UE && ~isempty( temp_UE_List)
             warning('downlink resource block is not fully utilized');
             pause;
          end

       if sum( a_i < 0 ,2)~=0 
          warning('a_i < 0');
          pause;
       end
       if sum( b_i < 0 ,2)~=0 
          warning('b_i < 0');
          pause;
       end



       %check:


      for ue = 1:TN_UE
          chv =  temp_UE_List(ue,6)/a_i(1,ue) + temp_UE_List(ue,7)/temp_UErate(ue,ibs)/b_i(1,ue) ;
           if chv > temp_UE_List(ue,8)
              warning('wrong kkt conditon calculation: delay constrant violated'); 
              warning([ 'Math: ' num2str(temp_UE_List(ue,6)) ' / ' num2str(a_i(1,ue)) ' + ' num2str(temp_UE_List(ue,7)) ' / ' num2str(temp_UErate(ue,ibs)) ' / ' num2str(b_i(1,ue)) ' = ' num2str(chv) ' > ' num2str(temp_UE_List(ue,8))]); 
              pause;
           end   
          UE_comneed_min(ue,1) = a_i(1,ue);
          DLRB_needed_min(ue,1)= b_i(1,ue);
      end
      

      if sum( b_i + ceil(temp_UE_List(:,9)'./temp_UErate(:,ibs)') ,2) > DL_avalRB || sum(a_i,2) >ca
         Valid = 0;
      end
      if sum( a_i < 0 ,2)~=0 || sum( b_i < 0 ,2)~=0 
         Valid = 0;
      end
      Com_needed_min=sum(a_i,2);
   end
end