function [com, DLRB] = minpower_COM_DLRB(c1,c2,c3,c4,c5_1,c5_2,c6_1,c6_2,c7)

%c1 = 10;
%c2 = 0.1;%MB
%c3 = 0.219;%MB/s,rb
%c4 = 0.1;%s
c5 = c5_1/c5_2^2; %1.45/4410^2; %W/MIPS^2
c6 = c6_1/c6_2;   %12/360; %W/rb
%c7 = 720;

C = [c1,c2,c3,c4,c5_1,c5_2,c6_1,c6_2,c7];

p = [2*c5*c4^2 -4*c5*c4*c1 2*c5*c1^2 -c2*c1*c6/c3];
r = roots(p);
flagi = zeros(1,3);

for i = 1:3
if isreal( r(i) ) 
    if r(i) > 0 && r(i) <= c5_2 && r(i) >= ( 1/( c3*c4*c7/c1/c2 - 1/c1 )/c4 + c1/c4 )
       flagi(i) = 1;
    end
end
end
% 
% flagi = zeros(1,3);
% for i = 1:3
% if isreal( r(i) ) 
%     if r(i) > 0 && r(i) <= c(6) && r(i) >= ( 1/( c(3)*c(4)*c(9)/c(1)/c(2) - 1/c(1) )/c(4) + c(1)/c(4) )
%        flagi(i) = 1;
%     end
% end
% end



if sum(flagi,2) > 1
   warning('minpower_COM_DLRB: more than two solutions, return te first'); 
   k = find(flagi);
   com = r(k(1));
   DLRB = ceil( c2*com/c3/(com*c4-c1) );
end
if sum(flagi,2) == 1
   k = find(flagi);
   com = r(k(1));
   DLRB = ceil( c2*com/c3/(com*c4-c1) );    
end
if sum(flagi,2) == 0
   warning('minpower_COM_DLRB: no solutions exists'); 
   ['p = [ ' num2str(2*c5*c4^2) '  ' num2str(-4*c5*c4*c1) '   ' num2str(2*c5*c1^2) '   ' num2str(-c2*c1*c6/c3) ' ]' ]
   C
end

end
% syms x
% eqn = 2*c5*x-c2*c1*c6/c3/(c4*x-c1)^2 == 0;
% [solx, params, conds] = solve(eqn, x, 'ReturnConditions', true);
% 
% syms z
% eqn1 = z^3 - 200*z^2 + 10000*z - 94447329657392904273920000/925285746146053797==0;
% solz = solve(eqn1,z);

% y = floor( 10*(1/c4/(c3*c4/c1/c2*c7-1/c1)+c1/c4) )/10:0.1:4410;
% Y = c5*y.^2 + c6*((c2/c3).*y)./(c4.*y-c1);
% plot(y,Y);