function [ Allocate_solar_BS_1day, flag] = solar_1cell_balancing_greedy(solar_BS_1s_1day,EnergyCom_BS)
global N_BS;

T_Last = size(solar_BS_1s_1day,2);
flag = 1;
battery = zeros(N_BS,1);
Allocate_solar_BS_1day= zeros(N_BS,T_Last);

for ts = 1:T_Last
       for b = 1:N_BS   
          if solar_BS_1s_1day(b,ts) > EnergyCom_BS(b,ts)
             Allocate_solar_BS_1day(b,ts) = EnergyCom_BS(b,ts);  
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts) - EnergyCom_BS(b,ts);
          elseif battery(b,1) + solar_BS_1s_1day(b,ts) > EnergyCom_BS(b,ts)
             Allocate_solar_BS_1day(b,ts) = EnergyCom_BS(b,ts);  
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts) - EnergyCom_BS(b,ts); 
          else 
             Allocate_solar_BS_1day(b,ts) = 0;
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts);
          end
           if  battery(b,1) < 1e-9
              warning('battery<0');
              flag = 0;
           end
       end
end




end