function Allocate_solar_BS_1day = solar_1cell_balancing_maxmin_sust(solar_BS_1s_1day,EnergyCom_BS)
global debug_variable_1
global debug_variable_2
global debug_variable_3
global N_BS;
global BSP_idle;
global MEP_idle;
    
     T =  size(solar_BS_1s_1day,2);
     Allocate_solar_BS_1day = solar_BS_1s_1day;


          for i = 1:T-1
              checkpt_sum1 = sum(Allocate_solar_BS_1day(:, T-i : T ),2 );
              if mod(i,1000) == 0
                disp([ 'balancing: i = ' num2str(i)]);
              end
              SutDflag = sum(Allocate_solar_BS_1day(:, T-i : T )<( BSP_idle+MEP_idle ),2 ) == 0;
              SutUflag = 1-SutDflag; %which SBS has sus problem
              %SutDflag = or(SutDflag,1);
              
              sumE = sum( Allocate_solar_BS_1day(:, T-i : T ),2 );
              sumP = sum( EnergyCom_BS(:, T-i : T ),2 );
              power_ratio = ( Allocate_solar_BS_1day(:, T-i : T )./EnergyCom_BS(:, T-i : T ) );
              avg_ratio = sumE./sumP;
              
              %extraE_flag = power_ratio(:,1) > avg_ratio

              extraE_flag1 = ( power_ratio(:,2:end) < avg_ratio ); 
              extraE_flag2 = ( Allocate_solar_BS_1day(:, T-i+1 : T ) < ( BSP_idle+MEP_idle ) ).*( repmat( SutUflag, 1, i ));
              %suminvR_s = sum( 1./power_ratio(:,2:end).*extraE_flag ,2 );
              
              neededE1 =  ( avg_ratio - power_ratio(:,2:end) ).*extraE_flag1 .*EnergyCom_BS(:, T-i+1 : T ); 
              neededE2 =  ( BSP_idle+MEP_idle - Allocate_solar_BS_1day(:, T-i+1 : T ) ) .*extraE_flag2;
              
              spareE_S= max( ( min( Allocate_solar_BS_1day(:, T-i )-( BSP_idle+MEP_idle ), sum(neededE2,2) ) ).*SutUflag,0);
              spareE  = zeros(N_BS,1);
              for b = 1:N_BS
                  if ~SutUflag(b,1)
                     spareE(b,1)  = max( ( Allocate_solar_BS_1day(b, T-i ) - avg_ratio(b,1).*EnergyCom_BS(b, T-i) ) ,0);
                  elseif Allocate_solar_BS_1day(b, T-i )-( BSP_idle+MEP_idle )<sum(neededE2(b,:),2)
                     spareE(b,1)  = 0;
                  else
                     spareE(b,1)  = max( ( Allocate_solar_BS_1day(b, T-i ) - sum(neededE2(b,:),2) - avg_ratio(b,1).*EnergyCom_BS(b, T-i) ) ,0); 
                  end
              end
              Allocate_solar_BS_1day(:, T-i ) = Allocate_solar_BS_1day(:, T-i ) - spareE - spareE_S;
              
              if sum(sum(( neededE1 < 0 ),2),1)>0 || sum(sum(( neededE2 < 0 ),2),1)>0
                 warning('neededE<0');
                 pause;
              end
              Deno_nE1 = sum(neededE1,2);
              Deno_nE2 = sum(neededE2,2);
              Distri_ratio1 = neededE1./Deno_nE1; 
              Distri_ratio2 = neededE2./Deno_nE2;
              if  size(Distri_ratio1,1)~=N_BS
                  warning('size of Distri_ratio is not right');
                  pause;
              end

              for b = 1:N_BS
                 if Deno_nE1(b,1)~= 0
                    if sum( extraE_flag1(b,:),2 ) == 0
                         warning('Deno_nE and extraE_flag is not match');
                         pause;
                     end
                    Allocate_solar_BS_1day(b, T-i+1:T ) = Allocate_solar_BS_1day(b, T-i+1:T ) +  spareE(b,1).* Distri_ratio1(b,:); 
                 end
                 if Deno_nE2(b,1)~= 0
                    if sum( extraE_flag2(b,:),2 ) == 0
                         warning('Deno_nE and extraE_flag is not match');
                         pause;
                     end
                    Allocate_solar_BS_1day(b, T-i+1:T ) = Allocate_solar_BS_1day(b, T-i+1:T ) +  spareE_S(b,1).* Distri_ratio2(b,:); 
                 end
                     if sum( isnan(Allocate_solar_BS_1day(b,:)), 2)> 0
                        warning('nan exsits');
                        b
                        i
                        spareE(b,1)
                        debug_variable_1 = extraE_flag(b,:);
                        debug_variable_2 = power_ratio(b,2:end);
                        %debug_variable_3 = ;
                        pause;
                     end
                 
              end
            
             if sum( abs(sum(Allocate_solar_BS_1day(:, T-i : T ) ,2) - checkpt_sum1 ),1)>i*1e-6
                warning('distribution of extra solar power is not well done:abs(sum(Allocate_solar_BS_1day(bs, T-i : T ) ) - checkpt_sum1 )>1e-6 ') 
                warning(['difference = ' num2str(sum( (sum(Allocate_solar_BS_1day(:, T-i : T ) ,2) - checkpt_sum1 ),1))]) 
                pause;
             end

             
         end
%          battery = zeros(N_BS,1);
%          for t = 1:T
%             for bs = 1:N_BS
%                if battery(bs,1) + Allocate_solar_BS_1day(bs,t) < BSP_idle + MEP_idle
%                   battery(bs,1) = battery(bs,1) + Allocate_solar_BS_1day(bs,t);
%                   Allocate_solar_BS_1day(bs,t) = 0;
%                elseif Allocate_solar_BS_1day(bs,t) < BSP_idle + MEP_idle
%                   battery(bs,1) = battery(bs,1);
%                   
%                end
%             end
%          end
end


     