function [battery_record,Asso_UE_guess_final,Allocate_solar_BS_1day_final,EnergyCom_BS_guess_final,Com_needed_guess_final,UE_comneed_min_final] = true_solar_alingment_ho(minpower,EnergyCom_BS_guess,Asso_UE_guess,solar_BS_1s_1day,Com_needed_guess,UE_comneed_min_guess,UE_XULrate_guess,UE_XDLrate_guess,UE_List_guess,N_UE_record,ID_Asso_UE_record)

global battery_initial_level;
global T_last;
global t_granu;
global N_BS;
global BSP_idle;
global MEP_idle;

%true solar alingment
%we have:
% Asso_UE_guess
% ULRB_needed_guess = ULRB_needed_min;
% DLRB_needed_guess = DLRB_needed_min;
% Com_needed_guess = Com_needed_min;
% solar_BS_1s_1day_true = solar_BS_1s_1day;
% 1.  create new Allocate_solar_BS_1day_true based on actual solar_BS_1s_1day, allocated power ratio and a battery
% ( try to reach the adjusted ratio, if more, store to battery, if less, drain from battery.
% 2. create new EnergyCom_BS_true, with initial value EnergyCom_BS_guess
% 3. for each BS, if EnergyCom_BS_true > Allocate_solar_BS_1day_true and battery has remaining power, 
% add the battery to  Allocate_solar_BS_1day_true until power = 1; if
% battery  = 0; start throw ue away.
battery_record               = zeros(N_BS,T_last/t_granu);
battery_record(:,1)          = battery_initial_level;
EnergyCom_BS_guess_final     = EnergyCom_BS_guess;
Allocate_solar_BS_1day_final = zeros(N_BS,T_last/t_granu);
%ULRB_needed_guess_final      = zeros(N_BS,T_last/t_granu);
%DLRB_needed_guess_final      = zeros(N_BS,T_last/t_granu);
Com_needed_guess_final       = zeros(N_BS,T_last/t_granu);
%UE_ListAssoAB_guess_final    = zeros( size(UE_ListAssoAB_guess)); 
UE_comneed_min_final         = zeros( size(UE_comneed_min_guess));
Asso_UE_guess_final          = Asso_UE_guess;

for ts = 1:T_last/t_granu
    TS_UE = N_UE_record(1,ts);
    UE_List_ts    = reshape( UE_List_guess(1:TS_UE,:,ts), [TS_UE , size(UE_List_guess,2)] );
    UE_XULrate_ts = reshape( UE_XULrate_guess(1:TS_UE,:,ts) ,[TS_UE,N_BS] ); 
    UE_XDLrate_ts = reshape( UE_XDLrate_guess(1:TS_UE,:,ts) ,[TS_UE,N_BS] ); 
    UE_comneed_min_ts = reshape( UE_comneed_min_guess(1:TS_UE,:,ts) ,[TS_UE,1] );
    if mod(ts,5000) == 0
       disp(['true solar adjustment: ' num2str(ts)] );
    end          
   for bs = 1:N_BS
       if solar_BS_1s_1day( bs , ts) >= EnergyCom_BS_guess_final( bs , ts )
   
          Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
          EnergyCom_BS_guess_final( bs , ts ) = EnergyCom_BS_guess( bs , ts );
          %ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
          %DLRB_needed_guess_final( bs , ts ) = DLRB_needed_guess( bs , ts );
          Com_needed_guess_final( bs , ts ) = Com_needed_guess( bs , ts );
          
          bflag = Asso_UE_guess_final(:,1,ts) == bs;
          UE_comneed_min_final(bflag,:,ts) = UE_comneed_min_guess(bflag,:,ts);
          %UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
          battery_record(bs,ts) = battery_record(bs,max(ts-1,1)) + solar_BS_1s_1day( bs , ts)-EnergyCom_BS_guess_final( bs , ts );
       else
              if battery_record(bs,max(ts-1,1))>= EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts)
               
                 Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
                 EnergyCom_BS_guess_final( bs , ts ) = EnergyCom_BS_guess( bs , ts );
                 %ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
                 %DLRB_needed_guess_final( bs , ts ) = DLRB_needed_guess( bs , ts );
                 Com_needed_guess_final( bs , ts ) = Com_needed_guess( bs , ts );
          
                 bflag = Asso_UE_guess_final(:,1,ts) == bs;
                 UE_comneed_min_final(bflag,:,ts) = UE_comneed_min_guess(bflag,:,ts);
                 %UE_ListAssoAB_guess_final(bflag,:,ts) = UE_ListAssoAB_guess(bflag,:,ts);
                 battery_record(bs,ts) = battery_record(bs,max(ts-1,1)) + solar_BS_1s_1day( bs , ts) - EnergyCom_BS_guess_final( bs , ts );
                 if battery_record(bs,ts) < 0
                    warning('battery level < 0');
                    pause;
                 end
              else
                
%                 chck_i = 0;
%                 if EnergyCom_BS_guess_final( bs , ts )~=  BSpowerf(0,0,0)
%                 disp('battery is not enough');
%                 chck_i = 1;
%                 bs
%                 ts
%                 EnergyCom_BS_guess_final( bs , ts ) 
%                 solar_BS_1s_1day( bs , ts)
%                 battery_record(bs,max(ts-1,1))
%                 pause;
%                 end
                %ULRB_needed_guess_final( bs , ts ) = ULRB_needed_guess( bs , ts );
                bflag = Asso_UE_guess_final(:,1,ts) == bs;
                %Idx_ue = find(bflag);
                TN_UE = sum(bflag,1);   
                Idx_ue_i = find(bflag);
                
                HOV_flag = false(TN_UE,1);
                NEW_flag = false(TN_UE,1);
                OTH_flag = false(TN_UE,1);
                for u = 1:TN_UE %current UE = Idx_ue(u,1);
                    preassoflag = ID_Asso_UE_record( Idx_ue_i(u,1) , 1, ts) == ID_Asso_UE_record(:,1,max(ts-1,1));
                    idx_u = find(preassoflag); %previous index of UE in ts-1 asso
                    if ~isempty(idx_u)
                      if Asso_UE_guess(idx_u, 1, max(ts-1,1))~= 0
                          if Asso_UE_guess( Idx_ue_i(u,1) , 1, ts) ~= Asso_UE_guess(idx_u, 1, max(ts-1,1))
                             %HOV_UE
                             HOV_flag(u,1) = 1;
                          else
                             %other UE    
                             OTH_flag(u,1) = 1;
                          end
                      else
                          %new ue
                          NEW_flag(u,1) = 1;
                      end
                    else
                        %new ue
                        NEW_flag(u,1) = 1;
                    end
                end                 
 %*****-*****%           
                [Idx_ue_prio,~,~] = priority_UE(bflag,HOV_flag,NEW_flag,OTH_flag,UE_List_ts,UE_XULrate_ts,UE_XDLrate_ts,UE_comneed_min_ts,bs);
 %*****^*****%                 
                while (  battery_record(bs,max(ts-1,1)) < EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts) && TN_UE > 0)
                  %disp([ 'TN_UE = ' num2str(TN_UE) ': enter while loop with battery_record(' num2str(bs) ' , ' num2str(ts-1) ' ) = '  num2str(battery_record(bs,ts-1)) ' < ' num2str(EnergyCom_BS_guess_final( bs , ts )) ' - ' num2str(solar_BS_1s_1day( bs , ts))]);
                  %start to drop

                  bflag = Asso_UE_guess_final(:,1,ts) == bs;
                  Idx_ue = find(bflag);
                  Idx_ue_econ = Idx_ue_prio(1,1);
                  
%                   if ts == 63386 && bs == 6
%                      Idx_ue
%                      ULRB_needed_guess_final( bs , ts )
%                      UE_List_guess( Idx_ue(Idx_ue_econ,1) , 5 , ts )
%                      UE_XULrate_guess(Idx_ue(Idx_ue_econ,1) , bs ,ts)
%                      Idx_ue_prio
%                   end
%                   Energ_cont = BSpowerf( ceil(UE_List_guess(bflag,5,ts)./UE_XULrate_guess(bflag,bs,ts)) , ...
%                                          reshape(UE_ListAssoAB_guess(bflag,3,ts),size(UE_List_guess(bflag,5,ts))) ,...
%                                          reshape(UE_ListAssoAB_guess(bflag,2,ts),size(UE_List_guess(bflag,5,ts))));
%                   if isequal(size(Energ_cont),size(bflag))
%                      warning('size of Energ_cont is not right'); 
%                   end
                  %[max_econ, Idx_ue_econ] =  max(Energ_cont,[],1); 
                  
                  %delete Idx_ue_econ(inside loop) or  Idx_ue(Idx_ue_econ,1)(outside loop)
                  %temp_ULRB_needed = ULRB_needed_guess_final( bs , ts ) - ceil( UE_List_guess( Idx_ue(Idx_ue_econ,1) , 5 , ts )/UE_XULrate_guess(Idx_ue(Idx_ue_econ,1) , bs ,ts) ) ;
                  Asso_UE_guess_final ( Idx_ue(Idx_ue_econ,1) , : , ts ) = reshape( 0  , size(Asso_UE_guess_final(1,:,1)) );
                  bflag( Idx_ue(Idx_ue_econ,1),1) = 0;
                  %disp('running minpower1BS_w_limComRB_func');
%*****-*****%
                  if minpower
                  [Com_needed_min_o, UE_comneed_min_o, Valid_temp_o] = minpower1BS_w_limComRB_func( UE_List_guess(bflag,:,ts)  ,  UE_XDLrate_guess(bflag,:,ts), bs );
                  else
                  [Com_needed_min_o, UE_comneed_min_o, Valid_temp_o] = minpower1BS_wo_limComRB_func( UE_List_guess(bflag,:,ts)  ,  UE_XDLrate_guess(bflag,:,ts), bs );
                  end
%*****^*****%
                  %disp('finished running minpower1BS_w_limComRB_func');
                     if Valid_temp_o == 0
                         warning('delete a ue and a_b_i become invalid'); 
                     end
%*****-*****%
                  %UE_ListAssoAB_guess_final( bflag , : , ts )                =  reshape( UE_ListAssoAB_temp_o , [ size(UE_ListAssoAB_temp_o) , 1 ] );
                  UE_comneed_min_final(bflag,:,ts) = reshape(UE_comneed_min_o, [ size(UE_comneed_min_o) , 1 ] );
                  %UE_ListAssoAB_guess_final( Idx_ue(Idx_ue_econ,1) , : , ts) =  zeros( size(UE_ListAssoAB_guess_final( Idx_ue(Idx_ue_econ,1) , : , 1)) );
                  UE_comneed_min_final( Idx_ue(Idx_ue_econ,1) , : , ts)  = zeros(size(UE_comneed_min_final( Idx_ue(Idx_ue_econ,1) , : , 1)));
                  %DLRB_needed_guess_final( bs , ts ) =  Resouce_needed_temp_o(1,2);
                  %ULRB_needed_guess_final( bs , ts ) =  temp_ULRB_needed;
                  Com_needed_guess_final( bs , ts )  =  Com_needed_min_o;        
                  EnergyCom_BS_guess_final( bs , ts ) =  BSpowerf_new(Com_needed_guess_final(bs,ts),UE_List_ts(bflag,:),UE_XULrate_ts(bflag,:),UE_XDLrate_ts(bflag,:),bs);
                  Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );
%*****^*****%
                  Idx_ue_prio = Idx_ue_prio - 1.*( Idx_ue_prio > Idx_ue_prio(1,1)  );
                  if Idx_ue_prio(1,1)~= Idx_ue_econ
                     warning('value of Idx_ue_econ changed');
                     pause;
                  end
                  Idx_ue_prio(1,:) = [];

                  TN_UE = sum(bflag,1); 
                end
                 if battery_record(bs,max(ts-1,1)) > EnergyCom_BS_guess_final( bs , ts ) - solar_BS_1s_1day( bs , ts)
                    battery_record(bs,ts) = battery_record(bs,max(ts-1,1)) + solar_BS_1s_1day( bs , ts) - EnergyCom_BS_guess_final( bs , ts );
                    Allocate_solar_BS_1day_final( bs , ts ) = EnergyCom_BS_guess_final( bs , ts );                    
                 else
                    if EnergyCom_BS_guess_final( bs , ts ) ~= BSP_idle + MEP_idle
                       warning('BS did not throw away all its UE before giving up using battery');
                       ts
                       bs
                       TN_UE
                       Com_needed_guess_final( bs , ts )
                       EnergyCom_BS_guess_final( bs , ts )
                       pause;
                    end
                    if TN_UE > 0 
                       warning('EnergyCom_BS_guess_final( bs , ts ) is not pushed to the minimum');
                    end
                    battery_record(bs,ts) = battery_record(bs,max(ts-1,1))+solar_BS_1s_1day( bs , ts);
                    %EnergyCom_BS_guess_final( bs , ts ) = 1e-3; %means that the BS is shut down
                    Allocate_solar_BS_1day_final( bs , ts )= 0;
                 end
%                  if chck_i
%                  EnergyCom_BS_guess_final( bs , ts ) 
%                  pause;
%                  end
              end
       end
       
   end
end
end