tng = rng;
Mul = 3;
%script
global T_last;
T_last = 86400;
global battery_initial_level;
battery_initial_level = 0;
%% DEBUG
global debug_variable_1
global debug_variable_2
global debug_variable_3
%% power parameters:
global Comp_fullW;
Comp_fullW = 1.45;
global Ca;
Ca = (4414)^2;
global ca;
ca = 4414;
global DL_fullW;
DL_fullW = 12;
global UL_fullW;
UL_fullW = 2;
global fullRB;
fullRB = 360;
global DL_avalRB;
DL_avalRB = 720;
global afa;
afa = Comp_fullW /Ca;
global bet;
bet = DL_fullW/fullRB;
global gam;
gam = UL_fullW/fullRB;

%% assign solar power
load('Solar_parced_data.mat');
Panelsize =  ( 0.2+0.2*0.3 ) *Mul;  %bifacial: 1.6+1.6*0.3
Enecov_eff = 0.18;
x_limit = 3014.87;
global N_BS;
BS_dist = 200;
N_BS = floor((x_limit-150)/200)+1;
Location_BS = zeros(N_BS,2);
for bs = 1:N_BS
    Location_BS(bs,:) = [BS_dist/2 + BS_dist(bs-1) 0.1];
%     scatter(Location_BS(bs,1),Location_BS(bs,2),'ro');
%     hold on
end
%---------------------------------------------------------------
%solar_EBU_1day = EBU1(72929+14400*2:72929+14400*2+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar_Mesa_1day = Mesa(72929+14400*2:72929+14400*2+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar_Mesa2_1day = EBU1(72929+14400:72929+14400+T_last-1); %72979 is 8AM, 44179 is 12AM
%solar to each basestation
%solar_BS_1s_1day = zeros(N_BS,T_last);
% for i = 1:N_BS
%     solarR = rand();
%     if solarR < 1/2
%      %solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_EBU_1day' *Enecov_eff*Panelsize; %0.15*0.6
%      solar_subR = 4*rand();
%      solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* EBU1(72929+14400+T_last*(floor(solar_subR)) : 72929+14400+T_last*(floor(solar_subR))+T_last-1)' *Enecov_eff*Panelsize; %0.15*0.6
%     elseif solarR>=1/2 && solarR < 1
%      %solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_Mesa_1day ' *Enecov_eff*Panelsize; %0.15*0.6
%      solar_subR = 4*rand();
%      solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* Mesa(72929+14400+T_last*(floor(solar_subR)) : 72929+14400+T_last*(floor(solar_subR))+T_last-1)' *Enecov_eff*Panelsize; %0.15*0.6
%     else
%      %solar_BS_1s_1day(i,:) = (0.4*rand(1,T_last)+0.8) .* solar_Mesa2_1day' *Enecov_eff*Panelsize; %0.15*0.6
%     end
% end

% ALL productive data
%while( min(sum(solar_BS_1s_1day,2)./sum(EnergyCom_BS_min,2),[],1) < 0.9 || min(sum(solar_BS_1s_1day,2)./sum(EnergyCom_BS_min,2),[],1) > 0.95)
while( min(sum(solar_BS_1s_1day,2)/11/T_last,[],1) < 1 )
deff_ratio = 0.2*rand(N_BS,1)+0.9;
solarR = 4*rand(N_BS,1);
solar_BS_1s_1day = solar_data_pros(ceil(solarR),:)*Enecov_eff*Panelsize.*deff_ratio;
end

%% UE generation
disp('calculate true solar result');
%rng(s);
run('C:\Users\ejm3bp6\Desktop\Boss\Green_HETNET_VANET_network_with_MEC_and_RE\simulation\0309_one_street_simulation\map_coordination_5BS.m');

%% noalg result(no balance, no min-power, no reassociation)
disp('true-solar: no algorithm');
[Battery_record_true_noalg,Asso_UE_record_true_noalg,Allocate_solar_BS_1day_true_final_noalg,EnergyCom_BS_true_final_noalg,...
 ULRB_needed_true_final_noalg,DLRB_needed_guess_true_noalg,Com_needed_true_final_noalg,UE_ListAssoAB_true_final_noalg]...
 = true_solar_alingment_ho(0,EnergyCom_BS_womin,Asso_UE_record_womin,UE_ListAssoAB_Record_womin,solar_BS_1s_1day,...
                        ULRB_needed_womin,DLRB_needed_womin,Com_needed_womin,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);
%solar generation:   solar_BS_1s_1day
%BS power needed:    EnergyCom_BS_womin
%BS power allocated: Allocate_solar_BS_1day_true_final_noalg
%battery level:      Battery_record_true_noalg
%outage:             Asso_UE_record_true_noalg



%% (whole alg) 
disp('true-solar: whole algorithm');
[Asso_UE_true_alg,EnergyCom_BS_true_alg,UE_ListAssoAB_true_alg,ULRB_needed_true_alg,DLRB_needed_true_alg,Com_needed_true_alg] ...
    = Reassociation_wm_ho(1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day,EnergyCom_BS_min,UE_ListAssoAB_Record,...
                       ULRB_needed_min,DLRB_needed_min,Com_needed_min);
casecount = zeros(N_BS,1);
for ts = 1:T_last
   for bs = 1:N_BS
      bflag =  Asso_UE_true_alg(:,ts) == bs;
      if ULRB_needed_true_alg( bs , ts ) ~= sum(ceil(UE_List_record(bflag,5,ts)./UE_XULrate_Record(bflag,bs,ts)),1)
         warning('ULRB not correct');
         pause;
      end
      if EnergyCom_BS_true_alg( bs , ts )>Allocate_solar_BS_1day( bs , ts )
         casecount(bs,1) = casecount(bs,1) + 1;
          if sum(bflag)~= 0
            warning('cases of EnergyCom_BS_true_alg( bs , ts )>Allocate_solar_BS_1day( bs , ts ) includes BS still have UE associated'); 
         end
      end
   end
end
Battery_record_alg = battery_transform(solar_BS_1s_1day,Allocate_solar_BS_1day);     
% [Battery_record_alg,Asso_UE_record_alg,Allocate_solar_BS_1day_alg,EnergyCom_BS_alg,...
%  ULRB_needed_alg,DLRB_needed_alg,Com_needed_alg,UE_ListAssoAB_alg]...
%  = true_solar_alingment_ho(1,EnergyCom_BS_true_alg,Asso_UE_true_alg,UE_ListAssoAB_true_alg,solar_BS_1s_1day,...
%                         ULRB_needed_true_alg,DLRB_needed_true_alg,Com_needed_true_alg,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);

%solar generation:   solar_BS_1s_1day
%BS power needed(before any alg):    EnergyCom_BS_womin
%BS power needed(after all alg) :    EnergyCom_BS_true_alg
%BS power allocated: Allocate_solar_BS_1day_alg(hould be the same as EnergyCom_BS_alg)
%battery level:      Battery_record_alg
%outage:             Asso_UE_record_alg
% if ~isequal(EnergyCom_BS_true_alg,EnergyCom_BS_alg)
%     warning('energy-needed changed after true_solar_alingment_ho');
%     pause;
% end   
% X = 1:T_last;
% plot(X,EnergyCom_BS_true_alg,X,EnergyCom_BS_alg);
filename = ['simulation_result_201803250243\simulation_resultwHO_multipleofsolarW = ' num2str(Mul) '.mat'];
save(filename);

%% balancing method1
disp('true-solar: whole algorithm  balancing method2');
[Asso_UE_true_algbm1,EnergyCom_BS_true_algbm1,UE_ListAssoAB_true_algbm1,ULRB_needed_true_algbm1,DLRB_needed_true_algbm1,Com_needed_true_algbm1] ...
    = Reassociation_wm_ho(1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day_method1,EnergyCom_BS_min,UE_ListAssoAB_Record,...
                       ULRB_needed_min,DLRB_needed_min,Com_needed_min);
[Battery_record_algbm1,Asso_UE_record_algbm1,Allocate_solar_BS_1day_algbm1,EnergyCom_BS_algbm1,...
 ULRB_needed_algbm1,DLRB_needed_algbm1,Com_needed_algbm1,UE_ListAssoAB_algbm1]...
 = true_solar_alingment_ho(1,EnergyCom_BS_true_algbm1,Asso_UE_true_algbm1,UE_ListAssoAB_true_algbm1,solar_BS_1s_1day,...
                        ULRB_needed_true_algbm1,DLRB_needed_true_algbm1,Com_needed_true_algbm1,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);


%% balancing method2
disp('true-solar: whole algorithm  balancing method2');
[Asso_UE_true_algbm2,EnergyCom_BS_true_algbm2,UE_ListAssoAB_true_algbm2,ULRB_needed_true_algbm2,DLRB_needed_true_algbm2,Com_needed_true_algbm2] ...
    = Reassociation_wm_ho(1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record,Allocate_solar_BS_1day_method2,EnergyCom_BS_min,UE_ListAssoAB_Record,...
                       ULRB_needed_min,DLRB_needed_min,Com_needed_min);
[Battery_record_algbm2,Asso_UE_record_algbm2,Allocate_solar_BS_1day_algbm2,EnergyCom_BS_algbm2,...
 ULRB_needed_algbm2,DLRB_needed_algbm2,Com_needed_algbm2,UE_ListAssoAB_algbm2]...
 = true_solar_alingment_ho(1,EnergyCom_BS_true_algbm2,Asso_UE_true_algbm2,UE_ListAssoAB_true_algbm2,solar_BS_1s_1day,...
                        ULRB_needed_true_algbm2,DLRB_needed_true_algbm2,Com_needed_true_algbm2,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);

filename = ['simulation_result_201803250243\simulation_resultwHO_multipleofsolarW = ' num2str(Mul) '.mat'];
save(filename);

%% with balancing&min-power, no-reassociaton
disp('true-solar: min BS power w/o reassociation');
[Asso_UE_true_norea,EnergyCom_BS_true_norea,...
    ULRB_needed_true_norea,DLRB_needed_true_norea,Com_needed_true_norea,UE_ListAssoAB_true_norea] ...
    = noreassociation_ho(1,EnergyCom_BS_min, Asso_UE_record,UE_ListAssoAB_Record,Allocate_solar_BS_1day,...
                      ULRB_needed_min,DLRB_needed_min,Com_needed_min,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);
[Battery_record_norea,Asso_UE_record_norea,Allocate_solar_BS_1day_norea,EnergyCom_BS_norea,...
 ULRB_needed_norea,DLRB_needed_norea,Com_needed_norea,UE_ListAssoAB_norea]...
 = true_solar_alingment_ho(1,EnergyCom_BS_true_norea,Asso_UE_true_norea,UE_ListAssoAB_true_norea,solar_BS_1s_1day,...
                        ULRB_needed_true_norea,DLRB_needed_true_norea,Com_needed_true_norea,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);
%solar generation:   solar_BS_1s_1day
%BS power needed(before any alg):    EnergyCom_BS_womin
%BS power needed(after all alg) :    EnergyCom_BS_norea
%BS power allocated: Allocate_solar_BS_1day_norea(hould be the same as EnergyCom_BS_alg)
%battery level:      Battery_record_norea
%outage:             Asso_UE_record_norea
if ~isequal(EnergyCom_BS_true_norea,EnergyCom_BS_norea)
    warning('energy-needed changed after true_solar_alingment_ho');
    pause;
end
%% with balancing&reassociaton no min-power
disp('true-solar: reassociation w/o min BS power');
[Asso_UE_true_womin,EnergyCom_BS_true_womin,UE_ListAssoAB_true_womin,ULRB_needed_true_womin,DLRB_needed_true_womin,Com_needed_true_womin] ...
    = Reassociation_wm_ho(0,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record_womin,Allocate_solar_BS_1day_womin,EnergyCom_BS_womin,UE_ListAssoAB_Record_womin,...
                       ULRB_needed_womin,DLRB_needed_womin,Com_needed_womin);
              
[Battery_record_true_womin,Asso_UE_record_true_womin,Allocate_solar_BS_1day_true_womin,EnergyCom_BS_true_final_womin,...
 ULRB_needed_true_final_womin,DLRB_needed_true_final_womin,Com_needed_true_final_womin,UE_ListAssoAB_true_final_womin]...
 = true_solar_alingment_ho(0,EnergyCom_BS_true_womin,Asso_UE_true_womin,UE_ListAssoAB_true_womin,solar_BS_1s_1day,...
                        ULRB_needed_true_womin,DLRB_needed_true_womin,Com_needed_true_womin,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);
%solar generation:   solar_BS_1s_1day
%BS power needed(before any alg):    EnergyCom_BS_womin
%BS power needed(after all alg) :    EnergyCom_BS_true_womin (or EnergyCom_BS_true_final_womin)
%BS power allocated: Allocate_solar_BS_1day_womin
%battery level:      Battery_record_true_womin
%outage:             Asso_UE_record_true_womin
if ~isequal(EnergyCom_BS_true_womin,EnergyCom_BS_true_final_womin)
    warning('energy-needed changed after true_solar_alingment_ho');
    pause;
end 
%% with reassociation and min-power, no balancing
disp('true-solar: with reassociation and min-power, no balancing');
[Asso_UE_true_wobal,EnergyCom_BS_true_wobal,UE_ListAssoAB_true_wobal,ULRB_needed_true_wobal,DLRB_needed_true_wobal,Com_needed_true_wobal] ...
    = Reassociation_wm_ho(1,UE_List_record,N_UE_record,ID_Asso_UE_record,UE_XULrate_Record,UE_XDLrate_Record,...
                       Asso_UE_record, Allocate_solar_BS_1day_wobal,EnergyCom_BS_min,UE_ListAssoAB_Record,...
                       ULRB_needed_min,DLRB_needed_min,Com_needed_min);
[Battery_record_true_wobal,Asso_UE_record_true_wobal,Allocate_solar_BS_1day_true_wobal,EnergyCom_BS_true_final_wobal,...
 ULRB_needed_true_final_wobal,DLRB_needed_true_final_wobal,Com_needed_true_final_wobal,UE_ListAssoAB_true_final_wobal]...
 = true_solar_alingment_ho(1,EnergyCom_BS_true_wobal,Asso_UE_true_wobal,UE_ListAssoAB_true_wobal,solar_BS_1s_1day,...
                        ULRB_needed_true_wobal,DLRB_needed_true_wobal,Com_needed_true_wobal,UE_XULrate_Record,UE_XDLrate_Record,UE_List_record,N_UE_record,ID_Asso_UE_record);
%solar generation:   solar_BS_1s_1day
%BS power needed(before any alg):    EnergyCom_BS_womin
%BS power needed(after all alg) :    EnergyCom_BS_true_final_wobal(or EnergyCom_BS_true_wobal)
%BS power allocated: Allocate_solar_BS_1day_wobal(or Allocate_solar_BS_1day_true_wobal)
%battery level:      Battery_record_true_wobal
%outage:             Asso_UE_record_true_wobal
if ~isequal(EnergyCom_BS_true_wobal,EnergyCom_BS_true_final_wobal)
    warning('energy-needed changed after true_solar_alingment_ho');
    pause;
end 
filename = ['simulation_result_201803250243\simulation_resultwHO_multipleofsolarW = ' num2str(Mul) '.mat'];
save(filename);