function [Asso_UE_record,EnergyCom_BS_min,UE_ListAssoAB_Record,ULRB_needed_min,DLRB_needed_min,Com_needed_min,Energy_outage] = Reassociation_wm(minpower,UE_List_record,N_UE_record,UE_XULrate_Record,UE_XDLrate_Record,Asso_UE_record,Allocate_solar_BS_1day,EnergyCom_BS_min,UE_ListAssoAB_Record,ULRB_needed_min,DLRB_needed_min,Com_needed_min)
global T_last;
global N_BS;
global Comp_fullW;
global Ca;
global ca;
global DL_fullW;
global UL_fullW;
global fullRB;
global DL_avalRB;
global afa;
global bet;
global gam;
%% Re-association:
   %BS_powerRatio_allt = Allocate_solar_BS_1day./EnergyCom_BS_min; %(N_BS,T_last)
   for ts = 1:T_last
    if mod(ts,5000) == 0
       disp(['Re-association: ' num2str(ts)] );
    end
       TS_UE = N_UE_record(1,ts);
       UE_List_ts    = reshape( UE_List_record(1:TS_UE,:,ts), [TS_UE , size(UE_List_record,2)] );
       UE_XDLrate_ts = reshape( UE_XDLrate_Record(1:TS_UE,:,ts) ,[TS_UE,N_BS] );
       UE_XULrate_ts = reshape( UE_XULrate_Record(1:TS_UE,:,ts) ,[TS_UE,N_BS] );
       asso_ts       = reshape( Asso_UE_record(1:TS_UE,:,ts),[TS_UE,1] );
%        Allocate_solar_BS_1day(:,ts); %(N_BS,ts)
%        EnergyCom_BS_min(:,ts);       %(N_BS,ts)
%        UE_ListAssoAB_Record(1:ue,:,ts); %(UE,3) 1:asso bs 2:a_i(allocated com) 3:b_i(allocated DLRB)
%        ULRB_needed_min(:,ts);        %(N_BS,ts)
%        DLRB_needed_min(:,ts);        %(N_BS,ts)
%        Com_needed_min(:,ts);         %(N_BS,ts)
       
       BS_powerRatio =  Allocate_solar_BS_1day(:,ts)./EnergyCom_BS_min(:,ts); %(N_BS,1)
       [S_BS_powerRatio, S_rt_idx] = sort(BS_powerRatio,'ascend');
       for bs = 1:N_BS
        power_flag = asso_ts == S_rt_idx(bs,1);
        power_flag_ck = reshape( UE_ListAssoAB_Record(1:TS_UE,1,ts), size(asso_ts) ) == S_rt_idx(bs,1);
        if  power_flag ~= power_flag_ck
             warning('wrong power_flag');
             pause;
        end
        Idx_ue = find(power_flag); % (TN_UE,1)
        TN_UE = sum(power_flag,1); 
        if S_BS_powerRatio(bs,1) < 1 && ~isempty(Idx_ue)
            ratio = S_BS_powerRatio(bs,1);
            Energ_cont = BSpowerf( ceil(UE_List_ts(power_flag,5)./UE_XULrate_ts(power_flag,S_rt_idx(bs,1))) , ...
                                     reshape(UE_ListAssoAB_Record(power_flag,3,ts),size(UE_List_ts(power_flag,5)))  ,...
                                     reshape(UE_ListAssoAB_Record(power_flag,2,ts),size(UE_List_ts(power_flag,5))) );            
            %method 1: find ue wirh largest energy contribution-> move it to second available BS
            [Sorted_econ, Idx_ue_econ] =  sort(Energ_cont,'descend'); 
            [Sorted_SINR, Idx_BS_SINR] = sort(UE_XULrate_ts(power_flag,:),2,'descend');
            tok_while = 1;
            while(ratio<1 && ~isempty(Idx_ue)) %target ue: Idx_ue_econ(tok_while,1) inside BS bs, Idx_ue(Idx_ue_econ(tok_while,1)  ,1) in UE_List
                %calculate T_rem
%                 T_rem = 1;
%                 while( Asso_UE_record( Idx_ue(Idx_ue_econ(tok_while,1)  ,1) ,ts+T_rem) == S_rt_idx(bs,1) ) %% can not write like this: this UE may disappear in the net time slot!!
%                     T_rem = T_rem+1;
%                     if ts + T_rem > T_last
%                        break; 
%                     end
%                 end
                if tok_while > TN_UE %searched all UE and ratio still < 1
                   %start throw ue wth highest power con away
                      power_flag_2 = asso_ts == S_rt_idx(bs,1);
                      power_flag_ck = reshape( UE_ListAssoAB_Record(1:TS_UE,1,ts), size(asso_ts) ) == S_rt_idx(bs,1);
                      if  power_flag_2 ~= power_flag_ck
                         warning('wrong power_flag');
                         pause;
                      end
                      Idx_ue = find(power_flag_2); % (TN_UE,1)
                      if isempty(Idx_ue)
                         break;
                      end
                      TN_UE = sum(power_flag_2,1); 
                      Energ_cont_2 = BSpowerf( ceil(UE_List_ts(power_flag_2,5)./UE_XULrate_ts(power_flag_2,S_rt_idx(bs,1))) , ...
                                               reshape(UE_ListAssoAB_Record(power_flag_2,3,ts),size(UE_List_ts(power_flag_2,5))) ,...
                                               reshape(UE_ListAssoAB_Record(power_flag_2,2,ts),size(UE_List_ts(power_flag_2,5))) );
                      [max_econ_2, Idx_ue_econ_2] =  max(Energ_cont_2,[],1);
                      
                      if ~isequal( size(Idx_ue_econ_2), [1,1] ) && ~isempty(Idx_ue_econ_2)
                         warning('max the wrong direction'); 
                         debug_vaiable4 = Energ_cont_2;
                         pause;
                      end
                      
                      %delete Idx_ue_econ_2(inside loop) or  Idx_ue(Idx_ue_econ_2,1)(outside loop)
                      temp_ULRB_needed = ULRB_needed_min( S_rt_idx(bs,1),ts) - ceil( UE_List_ts( Idx_ue(Idx_ue_econ_2,1) , 5 )/UE_XULrate_ts(Idx_ue(Idx_ue_econ_2,1) , S_rt_idx(bs,1) ) ) ;
                      Asso_UE_record ( Idx_ue(Idx_ue_econ_2,1) , : , ts ) = reshape( 0  , size(Asso_UE_record(1,:,1)) );
                      asso_ts( Idx_ue(Idx_ue_econ_2,1) ,1) = 0;
                      power_flag_2(Idx_ue(Idx_ue_econ_2,1),1) = 0;
                      if minpower 
                      [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_temp_o] = minpower1BS_w_limComRB_func( UE_List_ts(power_flag_2,:)  ,  UE_XDLrate_ts(power_flag_2,:), S_rt_idx(bs,1) );
                      else %minpower = 0
                      [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_temp_o] = minpower1BS_wo_limComRB_func( UE_List_ts(power_flag_2,:)  ,  UE_XDLrate_ts(power_flag_2,:), S_rt_idx(bs,1) );    
                      end
                      
                      if Valid_temp_o == 0
                         warning('delete a ue and a_b_i become invalid');
                         UE_ListAssoAB_temp_o
                         Idx_ue(Idx_ue_econ_2,1)
                         S_rt_idx(bs,1)
                         UE_ListAssoAB_Record( [ find(power_flag_2) ; Idx_ue(Idx_ue_econ_2,1) ] , : , ts )
                         pause;
                      end
                      UE_ListAssoAB_Record( power_flag_2 , : , ts ) =  reshape( UE_ListAssoAB_temp_o , [ size(UE_ListAssoAB_temp_o) , 1 ] );
                      UE_ListAssoAB_Record( Idx_ue(Idx_ue_econ_2,1) , : , ts) = zeros( size(UE_ListAssoAB_Record( Idx_ue(Idx_ue_econ_2,1) , : , 1)) );
                      
                      DLRB_needed_min( S_rt_idx(bs,1), ts ) =  Resouce_needed_temp_o(1,2);
                      ULRB_needed_min( S_rt_idx(bs,1), ts ) = temp_ULRB_needed;
                      Com_needed_min ( S_rt_idx(bs,1), ts ) = Resouce_needed_temp_o(1,1);        
                      EnergyCom_BS_min(:,ts) =BSpowerf(ULRB_needed_min(:,ts),DLRB_needed_min(:,ts),Com_needed_min(:,ts));
                      ratio = Allocate_solar_BS_1day( S_rt_idx(bs,1),ts)/EnergyCom_BS_min( S_rt_idx(bs,1),ts);
                       
                           if sum(sum(EnergyCom_BS_min<0,1),2) ~=0
                              warning('EnergyCom_BS_min < 0');
                              pause;
                           end                      
                else
                %move ue to other bs
                
%                 if Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , 1 ) ~= S_rt_idx(bs,1)
%                     warning('assumption that all assciated ue is connected to its highest SINR BS is violated ');
%                     pause;
%                 end
                for tarbs = 0:N_BS-1   %target bs: Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 ) % under the assumption that all assciated ue is connected to its highest SINR BS.  
                  Resso = 1;         %target ue: Idx_ue_econ(tok_while,1) inside BS bs, Idx_ue(Idx_ue_econ(tok_while,1)  ,1) in UE_List
                  if Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ) == S_rt_idx(bs,1) 
                      Resso = 0; 
                  end
                  if Resso
                  for t = 1:1 %T_rem: Once we find a way to retreat the exact UE information of this ue after time ts, we can add T_rem back 
% for T_rem          if BS_powerRatio_allt(Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ),ts-1+T_rem ) <= 1 || UE_List_record( Idx_ue(Idx_ue_econ(tok_while,1)  ,1) , 5 , ts-1+T_rem)/Sorted_SINR(Idx_ue_econ(tok_while,1),tarbs+1 ) > ca
% for T_rem             Resso = 0;   
% for T_rem          end
                     tar_BS_flag = asso_ts == Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 );

                     Con1 = BS_powerRatio(Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ),1) <= 1;
                     Con2 = ceil( UE_List_ts( Idx_ue(Idx_ue_econ(tok_while,1)  ,1) , 5 )/Sorted_SINR(Idx_ue_econ(tok_while,1),tarbs+1 ) )> ( DL_avalRB - ULRB_needed_min( Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ),ts) ) ;
                     Con3 = ceil( UE_List_ts( Idx_ue(Idx_ue_econ(tok_while,1)  ,1) , 9 )/UE_XDLrate_ts(Idx_ue(Idx_ue_econ(tok_while,1)  ,1),Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 ) ) ) > (DL_avalRB - sum( ceil(UE_List_ts( tar_BS_flag , 9 )./UE_XDLrate_ts(tar_BS_flag,Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 ))),1)  );
                     if ~isequal(size(Con1),size(Con2),size(Con3),[1,1])
                        warning('dimension of Con1~3 is not well maintained'); 
                        pause;
                     end
                     if Con1 || Con2 || Con3
                        Resso = 0;  
                     end
                  end
                  end
                  
                  if Resso
                     ntflag = asso_ts == Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 );
                     if minpower 
                     [UE_ListAssoAB_temp, Resouce_needed_temp, Valid_temp] = minpower1BS_w_limComRB_func( [ UE_List_ts(ntflag,:);UE_List_ts(Idx_ue(Idx_ue_econ(tok_while,1)  ,1),:)]  , [ UE_XDLrate_ts(ntflag,:); UE_XDLrate_ts(Idx_ue(Idx_ue_econ(tok_while,1)  ,1),:)], Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 ));
                     else
                     [UE_ListAssoAB_temp, Resouce_needed_temp, Valid_temp] = minpower1BS_wo_limComRB_func( [ UE_List_ts(ntflag,:);UE_List_ts(Idx_ue(Idx_ue_econ(tok_while,1)  ,1),:)]  , [ UE_XDLrate_ts(ntflag,:); UE_XDLrate_ts(Idx_ue(Idx_ue_econ(tok_while,1)  ,1),:)], Idx_BS_SINR( Idx_ue_econ(tok_while,1)  , tarbs+1 ));                  
                     end
                  
                     if ~Valid_temp  %Resouce_needed_temp(1,1) > ca || Resouce_needed_temp(1,2) > DL_avalRB
                        Resso = 0;   
                     end
                  end
                  
                  if Resso
                    temp_ULRB_needed = ULRB_needed_min( Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ),ts) + ceil( UE_List_ts( Idx_ue(Idx_ue_econ(tok_while,1)  ,1) , 5 )/Sorted_SINR(Idx_ue_econ(tok_while,1),tarbs+1 ) );
                    if BSpowerf(temp_ULRB_needed,Resouce_needed_temp(1,2),Resouce_needed_temp(1,1)) <= Allocate_solar_BS_1day(Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ),ts)
                       %move to new bs
                       Asso_UE_record ( Idx_ue(Idx_ue_econ(tok_while,1)  ,1),:,ts) = reshape( Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 )  , size(Asso_UE_record(1,:,1)) );
                       
                       Debug_asso = asso_ts;%before changed asso_ts
                       asso_ts( Idx_ue(Idx_ue_econ(tok_while,1),1) ,1) = Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 );
                       
                       
                       DLRB_needed_min( Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ), ts ) =  Resouce_needed_temp(1,2);
                       ULRB_needed_min( Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ), ts ) = temp_ULRB_needed;
                       Com_needed_min ( Idx_BS_SINR( Idx_ue_econ(tok_while,1)  ,tarbs+1 ), ts ) = Resouce_needed_temp(1,1);
                       UE_ListAssoAB_Record( [ find(ntflag) ; Idx_ue(Idx_ue_econ(tok_while,1),1) ] , : , ts ) =  reshape( UE_ListAssoAB_temp , [ size(UE_ListAssoAB_temp) , 1 ] );                       
                       
                       Debug_nsflag = Debug_asso==S_rt_idx(bs,1); %nsflag before changed
%                        if minpower
%                        [UE_ListAssoAB_temp_d, Resouce_needed_temp_d, Valid_d] = minpower1BS_w_limComRB_func( UE_List_ts(Debug_nsflag,:)  , UE_XDLrate_ts(Debug_nsflag,:), S_rt_idx(bs,1));
%                        else
%                        [UE_ListAssoAB_temp_d, Resouce_needed_temp_d, Valid_d] = minpower1BS_wo_limComRB_func( UE_List_ts(Debug_nsflag,:)  , UE_XDLrate_ts(Debug_nsflag,:), S_rt_idx(bs,1));                           
%                        end
                       nsflag = asso_ts == S_rt_idx(bs,1); %update the original bs's energy & resource condition
                       if minpower
                       [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_o] = minpower1BS_w_limComRB_func( UE_List_ts(nsflag,:)  , UE_XDLrate_ts(nsflag,:), S_rt_idx(bs,1));
                       else
                       [UE_ListAssoAB_temp_o, Resouce_needed_temp_o, Valid_o] = minpower1BS_wo_limComRB_func( UE_List_ts(nsflag,:)  , UE_XDLrate_ts(nsflag,:), S_rt_idx(bs,1));
                       end
                       if Valid_o == 0
                          warning('invalid BS resource allocation happened when removing one ue from a valid BS'); 
                          pause;
                       end
                       ULRB_needed_min( S_rt_idx(bs,1) , ts ) = ULRB_needed_min( S_rt_idx(bs,1) , ts ) - ceil( UE_List_ts( Idx_ue(Idx_ue_econ(tok_while,1)  ,1) , 5 )/Sorted_SINR(Idx_ue_econ(tok_while,1) ,1 ) );
                       DLRB_needed_min( S_rt_idx(bs,1) , ts ) = Resouce_needed_temp_o(1,2);
                       Com_needed_min ( S_rt_idx(bs,1) , ts ) = Resouce_needed_temp_o(1,1);
                       % NO, its not! UE_ListAssoAB_Record has been updated in previous step
                       
                       UE_ListAssoAB_Record( nsflag , : , ts ) =  reshape( UE_ListAssoAB_temp_o , [ size(UE_ListAssoAB_temp_o) , 1 ] );
                       EnergyCom_BS_min(:,ts) =BSpowerf(ULRB_needed_min(:,ts),DLRB_needed_min(:,ts),Com_needed_min(:,ts));
                       ratio = Allocate_solar_BS_1day( S_rt_idx(bs,1),ts)/EnergyCom_BS_min( S_rt_idx(bs,1),ts);
                       
                           if sum(sum(EnergyCom_BS_min<0,1),2) ~=0
                              warning('EnergyCom_BS_min < 0');
                              pause;
                           end
                       
                       break; %avoid for search all remaining bs and add the ue to the bs with lower SINR
                       
                    end 
                  end
                end % endof for tarbs = 1:N_BS-1
                end
                
                
                tok_while = tok_while +1;
            end % end of while
        end
       end
       %TODO: add those asso == 0 UE back if possible
       %need to update asso_ts, BS_power_ratio
       asso_ts_new       = reshape( Asso_UE_record(1:TS_UE,:,ts),[TS_UE,1] );
       BS_powerRatio     = Allocate_solar_BS_1day(:,ts)./EnergyCom_BS_min(:,ts);
       if ~isequal(asso_ts,asso_ts_new)
          warning('Asso_UE_record is not well maintained');
          pause;
       end
       zero_flag = asso_ts == 0;
       zero_flag_ck = reshape( UE_ListAssoAB_Record(1:TS_UE,1,ts), size(asso_ts) ) == 0;
       if  zero_flag ~= zero_flag_ck
           warning('wrong zero_flag'); 
            pause;
       end
       Idx_ue = find(zero_flag); % (TN_UE,1)
       TN_UE = sum(zero_flag,1); 
       [Sorted_SINR, Idx_BS_SINR] = sort(UE_XULrate_ts(zero_flag,:),2,'descend');
       for ue = 1:TN_UE
          add_zeroflag = 0;
          zbs = 0;
          while ~add_zeroflag && zbs < N_BS
            zbs = zbs +1;
            add_zeroflag = 1;
          % for the remaining BS
          %target ue: Idx_ue(ue,1); for outside(before zeroflag) index, ue for inside(after zeroflag) index
          %target bs: Idx_BS_SINR(ue,zbs), zbs in Sorted_SINR
           
          %check target bs has enough power
          
          Con1 =  BS_powerRatio(Idx_BS_SINR(ue,zbs),1) <= 1 ;
          %check remaining UL link can afford new ue
          if DL_avalRB < ULRB_needed_min( Idx_BS_SINR(ue,zbs) , ts )
              warning('allocated ULRB > available ULRB');
              pause;
          end
          Con2 = UE_List_ts( Idx_ue(ue  ,1) , 5 )/UE_XULrate_ts( Idx_ue(ue  ,1) ,Idx_BS_SINR(ue,zbs) ) > DL_avalRB -  ULRB_needed_min( Idx_BS_SINR(ue,zbs) , ts )  ;  
          %check the remaining DLRB can afford DL stream
          if DL_avalRB < DLRB_needed_min( Idx_BS_SINR(ue,zbs) , ts )
              warning('allocated DLRB > available DLRB');
              pause;
          end          
          Con3 = UE_List_ts( Idx_ue(ue  ,1) , 9 )/UE_XDLrate_ts( Idx_ue(ue  ,1) ,Idx_BS_SINR(ue,zbs) ) > DL_avalRB -  DLRB_needed_min( Idx_BS_SINR(ue,zbs) , ts )  ;
          
          if Con1 || Con2 || Con3
             add_zeroflag = 0;
          end
          if add_zeroflag
          %check after add this ue, there are valid solution of a_i and b_i
            nzflag = asso_ts == Idx_BS_SINR(ue,zbs);
            if minpower
            [UE_ListAssoAB_tempz, Resouce_needed_tempz, Valid_tempz] = minpower1BS_w_limComRB_func( [ UE_List_ts(nzflag,:);UE_List_ts(  Idx_ue(ue  ,1) , : ) ]  , [ UE_XDLrate_ts(nzflag,:); UE_XDLrate_ts(Idx_ue(ue  ,1) ,:)], Idx_BS_SINR(ue,zbs) );  
            else
            [UE_ListAssoAB_tempz, Resouce_needed_tempz, Valid_tempz] = minpower1BS_wo_limComRB_func( [ UE_List_ts(nzflag,:);UE_List_ts(  Idx_ue(ue  ,1) , : ) ]  , [ UE_XDLrate_ts(nzflag,:); UE_XDLrate_ts(Idx_ue(ue  ,1) ,:)], Idx_BS_SINR(ue,zbs) );  
            end
            
            %check the valid solution will not make power ratio > 1
            if Valid_tempz
               temp_ULRB_needed = UE_List_ts( Idx_ue(ue  ,1) , 5 )/UE_XULrate_ts( Idx_ue(ue  ,1) ,Idx_BS_SINR(ue,zbs) )+ULRB_needed_min( Idx_BS_SINR(ue,zbs) , ts ) ;
               temp_power = BSpowerf(temp_ULRB_needed,Resouce_needed_tempz(1,2),Resouce_needed_tempz(1,1));
               if temp_power <= Allocate_solar_BS_1day(Idx_BS_SINR(ue,zbs),ts)
                  %move this ue to target bs
                   Asso_UE_record ( Idx_ue(ue,1),:,ts) = reshape( Idx_BS_SINR(ue,zbs)  , size(Asso_UE_record(1,:,1)) );
                   asso_ts( Idx_ue(ue,1) ,1) = Idx_BS_SINR(ue,zbs) ;
                   
                   DLRB_needed_min( Idx_BS_SINR(ue,zbs), ts ) = Resouce_needed_tempz(1,2);
                   ULRB_needed_min( Idx_BS_SINR(ue,zbs), ts ) = temp_ULRB_needed;
                   Com_needed_min ( Idx_BS_SINR(ue,zbs), ts ) = Resouce_needed_tempz(1,1);
                   % need to change UE_ListAssoAB_Record
                   UE_ListAssoAB_Record( [ find(nzflag) ; Idx_ue(ue,1) ] , : , ts ) =  reshape( UE_ListAssoAB_tempz , [ size(UE_ListAssoAB_tempz) , 1 ] );
                   
                   EnergyCom_BS_min(:,ts) = BSpowerf(ULRB_needed_min(:,ts),DLRB_needed_min(:,ts),Com_needed_min(:,ts));
                   BS_powerRatio          = Allocate_solar_BS_1day(:,ts)./EnergyCom_BS_min(:,ts);
                   
                      if sum(sum(EnergyCom_BS_min<0,1),2) ~=0
                         warning('EnergyCom_BS_min < 0');
                         pause;
                      end
               else
                  add_zeroflag = 0;  
               end
            else
               add_zeroflag = 0; 
            end
          end
          end
       end
       
       
       
   end                      

    
%% Statistics
% Battery_level = zeros(N_BS,1);
% for b = 1:N_BS
% for i = 60000:T_last
%     if EnergyCom_BS_min(b,i)>solar_BS_1s_1day(b,i)
%     Battery_level(b,1) = Battery_level(b,1)+EnergyCom_BS_min(b,i)-solar_BS_1s_1day(b,i);
%     end
% end
% end
% 
% for b = 1:N_BS
% for i = 1:28000
%     if EnergyCom_BS_min(b,i)>solar_BS_1s_1day(b,i)
%     Battery_level(b,1) = Battery_level(b,1)+EnergyCom_BS_min(b,i)-solar_BS_1s_1day(b,i);
%     end
% end
% end



end