function [UE_ULXRateperW,UE_DLXRateperW,UE_BS_distance] = SINR_calc(UE_List,Location_BS,UE_Xmitpower,BS_Xmitpower,Noise,km,BW,Fc)
N = size( UE_List, 1);
B = size(Location_BS,1);

%UE_SINR = zeros(N,B);
%UE_DLSINR= zeros(N,B);
%UE_BS_distance = zeros(N,B);
%UE_ULXRateperW = zeros(N,B);
%UE_DLXRateperW= zeros(N,B);
%calculate distance
UE_BS_distance = sqrt( ( UE_List(:,3)-Location_BS(:,1)' ).^2 + ( UE_List(:,4)-Location_BS(:,2)' ).^2  );
% for j = 1:N
%     for k = 1:B
%         UE_BS_distance(j,k) =  sqrt( ( UE_List(j,3) - Location_BS(k,1) )^2 + (UE_List(j,4) - Location_BS(k,2))^2 );
%     end
% end

% 
% %Macro BS
% for i = 1:N
%     UE_SINR(i,1) = 10^( 0.1*(UE_Xmitpower - Noise - 128.1 - 36.7 * log10( UE_BS_distance(i,1)/km ) ));
% end
% %other SBSs

FFAD = normrnd(0,8,[N,B]);

log_UED = 22.7 + 26*log10(Fc) + 36.7 * log10( UE_BS_distance );

UE_SINR   = 10.^(0.1*(UE_Xmitpower-log_UED - Noise - FFAD));
UE_DLSINR = 10.^(0.1*(BS_Xmitpower-log_UED - Noise - FFAD));

% for j = 1:N
%    for k = 1:B
%       FFAD = normrnd(0,8);
%       UE_SINR(j,k) = 10^( 0.1*((UE_Xmitpower)-( 22.7 + 26*log10(Fc) + 36.7 * log10( UE_BS_distance(j,k))) - Noise - FFAD));  
%       UE_DLSINR(j,k) = 10^(0.1*((BS_Xmitpower)-( 22.7 + 26*log10(Fc) + 36.7 * log10( UE_BS_distance(j,k))) - Noise - FFAD)); 
%    end
% end

UE_ULXRateperW = BW*log2(1+UE_SINR);
UE_DLXRateperW = BW*log2(1+UE_DLSINR);
% for j = 1:N
%    for k = 1:B
%       UE_ULXRateperW(j,k) = BW*log2(1+UE_SINR(j,k));
%       UE_DLXRateperW(j,k) = BW*log2(1+UE_DLSINR(j,k));
%    end
% end
end