%% plot: energy(guess with reasso, minpower) , solar(guess,Wmin),solar(true,Wmin)
%initialize
EnergyCom_BS                   = EnergyCom_BS_guess_final_wm ;
solar_BS_1s_1day_target        = solar_BS_1s_1day_guess;
solar_BS_1s_1day_true = solar_BS_1s_1day;

Min_EnergyCom_BS = zeros(N_BS,T_last/60);
Min_solar_BS_1s_1day = zeros(N_BS,T_last/60);
Min_solar_BS_1s_1day_t = zeros(N_BS,T_last/60);
for i = 1:T_last/60
    for u = 1:60
        Min_EnergyCom_BS(:,i) = Min_EnergyCom_BS(:,i)+EnergyCom_BS(:,(i-1)*60+u);
        Min_solar_BS_1s_1day(:,i) = Min_solar_BS_1s_1day(:,i) + solar_BS_1s_1day_target(:,(i-1)*60+u);
        Min_solar_BS_1s_1day_t(:,i) = Min_solar_BS_1s_1day_t(:,i) + solar_BS_1s_1day_true(:,(i-1)*60+u);
    end
    
end

K =3;
X = 1:T_last/60;
%yyaxis left
%X = 1:T_last
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
%plot(X,Min_EnergyCom_BS(K,:)./60,'b',X,Min_solar_BS_1s_1day(K,:)./60,'r',X, Min_solar_BS_1s_1day_t(K,:)./60,'g');
%legend('Small cell energy consumption','solar power prediction','true solar power data');
plot(X,Min_EnergyCom_BS(K,:)./60,'k',X, Min_solar_BS_1s_1day_t(K,:)./60,'b');
legend('Small cell energy consumption','true solar power data');
ylabel('W');
title(['Small basestation ' num2str(K)]);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);



%% plot adjust_power_ratio(guess) AND original power ratio 

Min_solar_BS_1s_1day = zeros(N_BS,1440);
Min_Allocate_solar_BS_1day_f = zeros(N_BS,T_last/60);
Min_Allocate_solar_BS_1day = zeros(N_BS,T_last/60);
Min_EnergyCom_BS = zeros(N_BS,T_last/60);
Min_EnergyCom_BS_f = zeros(N_BS,T_last/60);
Min_EnergyCom_BS_afreasso= zeros(N_BS,T_last/60);
for i = 1:T_last/60
    for u = 1:60
        Min_solar_BS_1s_1day(:,i)          = Min_solar_BS_1s_1day(:,i)        +  solar_BS_1s_1day_guess(:,(i-1)*60+u);
        Min_EnergyCom_BS(:,i)              = Min_EnergyCom_BS(:,i)            +  EnergyCom_BS_prereasso(:,(i-1)*60+u);
        Min_EnergyCom_BS_afreasso(:,i)     = Min_EnergyCom_BS_afreasso(:,i)   +  EnergyCom_BS_guess(:,(i-1)*60+u);
        Min_Allocate_solar_BS_1day(:,i)    = Min_Allocate_solar_BS_1day(:,i)  +  Allocate_solar_BS_1day_guess(:,(i-1)*60+u);
        Min_Allocate_solar_BS_1day_f(:,i)  = Min_Allocate_solar_BS_1day_f(:,i)+  Allocate_solar_BS_1day_final_wm(:,(i-1)*60+u);
        Min_EnergyCom_BS_f(:,i)            = Min_EnergyCom_BS_f(:,i)          +  EnergyCom_BS_guess_final_wm(:,(i-1)*60+u);
    end
end
Min_adjust_power_ratio = Min_Allocate_solar_BS_1day./Min_EnergyCom_BS;
Min_adjust_power_ratio_f = Min_Allocate_solar_BS_1day_f./Min_EnergyCom_BS_f;

X = 1:T_last/60;
K = 2;
plot(X,Min_solar_BS_1s_1day(K,:)./Min_EnergyCom_BS(K,:),'b',X,Min_adjust_power_ratio(K,:),'g',X,Min_adjust_power_ratio_f(K,100)*ones(1,T_last/60),'r',X,Min_Allocate_solar_BS_1day(K,:)./Min_EnergyCom_BS_afreasso(K,:),'k');%X,Min_EnergyCom_BS(K,:)./Min_solar_BS_1s_1day(K,:),'b'
ylabel('ratio');
title(['Power ratio(solar/consume) Small basestation ' num2str(K)]);
ylim([0 inf]);
xlabel('TIME');
xticks([1 7200/60:7200/60:T_last/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);
legend( 'power ratio before adjusted','power ratio adjusted(balancing) by guessed solar','power ratio adjusted(balancing+reassociation) by guessed solar','power ratio after applying true solar data');


%% Just solar
%solar
%solar_EBU_1day = Mesa2(72929:72929+86400-1);
Min_solar_BS_1s_1day = zeros(N_BS,1440);
Min_solar_BS_1s_1day_t = zeros(N_BS,1440);
for i = 1:1440
    for u = 1:60
        Min_solar_BS_1s_1day(:,i)   = Min_solar_BS_1s_1day(:,i)+solar_BS_1s_1day_guess(:,(i-1)*60+u);
        Min_solar_BS_1s_1day_t(:,i) = Min_solar_BS_1s_1day_t(:,i)+solar_BS_1s_1day_true(:,(i-1)*60+u);
    end
    
end

K =3;
X = 1:1440;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
plot(X,Min_solar_BS_1s_1day(K,:)./60,'g',X,Min_solar_BS_1s_1day_t(K,:)./60,'b');
legend('predicted solar data','true solar data');
ylabel('W');
title(['Small basestation ' num2str(K)]);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:86400/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 86400/60]);


%% unasso and N_UE

unasso_guessf = zeros(1,T_last/60);
unasso_guess = zeros(1,T_last/60);
unasso_true = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        unasso_guessf(1,t) = unasso_guessf(1,t) + sum(Asso_UE_guess_final_wm(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        %unasso_guess(1,t) = unasso_guess(1,t) + sum(Asso_UE_guess(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_true(1,t) = unasso_true(1,t) + sum(Asso_UE_true(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
    end
end


MUE_min = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        MUE_min(1,t) = MUE_min(1,t) + N_UE_guess(1,(t-1)*60+u);
    end
end


K =3;
X = 1:T_last/60;
figure(50+K)
yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
% plot(X,unasso_guessf./60,'r',X,unasso_guess./60,'g',X,unasso_true./60,'b');
% legend('by predicted solar data','by predicted solar data before use true solar data calibration', 'by true solar data');

plot(X,unasso_guessf./MUE_min*100,'g',X,unasso_true./MUE_min*100,'b');

ylabel('service outage rate');
title(['service outage rate']);
ylim([0 1]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

yyaxis right
plot(X,MUE_min./60,'k');
ylabel('number of UE');
ylim([0 inf]);
legend('by predicted solar data', 'by true solar data','number of UE');
str = {['average service outage(predicted solar) = ' num2str(sum(unasso_guessf,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(known solar) = ' num2str(sum(unasso_true,2)/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');
%% battery
battery_min = zeros(N_BS,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        battery_min(:,t) = battery_min(:,t) + battery_record_wm(:,(t-1)*60+u);
    end
end

for k = 3:3

K =k;
X = 1:T_last/60;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
figure(k);
plot(X,battery_min(K,:)./60,'r');
legend('battery level(J)');
%plot(X,unasso_guess./60,'g',X,unasso_true./60,'b');
%legend('by predicted solar data before use true solar data calibration', 'by true solar data');
ylabel('J: averag in one minute');
title(['battery level - Small basestation ' num2str(K)]);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'})
xlim([0 T_last/60]);
str = ['max battery level = ' num2str(max(battery_min(K,:),[],2)/60/3600) ' (Whr)'];
annotation('textbox','String',str,'FitBoxToText','on');
end
%% unasso & handover
unasso_true = zeros(1,T_last);
unasso_ori = zeros(1,T_last);
unasso_true_womin = zeros(1,T_last); 
unasso_true_norea = zeros(1,T_last); 
hover_true = zeros(1,T_last);
hover_ori = zeros(1,T_last);   %Asso_UE_record
hover_true_womin = zeros(1,T_last); %Asso_UE_true_womin 
hover_true_norea  = zeros(1,T_last);  %Asso_UE_true_norea_womin
for  ts = 2:T_last
    for u = 1:N_UE_guess(1,ts)
        preassoflag = ID_Asso_UE_record(u,1,ts) == ID_Asso_UE_record(:,1,ts-1);
        idx_u = find(preassoflag);
        if Asso_UE_true(u, ts) == 0
           unasso_true(1,ts) = unasso_true(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_true(u, 1, ts) ~= Asso_UE_true(idx_u, 1, ts-1) && Asso_UE_true(idx_u, 1, ts-1)~= 0
              hover_true(1,ts)  = hover_true(1,ts)  + 1;
           end
        end
        if Asso_UE_true_womin(u, ts) == 0
           unasso_true_womin(1,ts) = unasso_true_womin(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_true_womin(u, 1, ts) ~= Asso_UE_true_womin(idx_u, 1, ts-1) && Asso_UE_true_womin(idx_u, 1, ts-1)~= 0
              hover_true_womin(1,ts)  = hover_true_womin(1,ts)  + 1;
           end
        end                     
        if Asso_UE_record_womin(u, ts) == 0
           unasso_ori(1,ts) = unasso_ori(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_record_womin(u, 1, ts) ~= Asso_UE_record_womin(idx_u, 1, ts-1) && Asso_UE_record_womin(idx_u, 1, ts-1)~= 0
              hover_ori(1,ts)  = hover_ori(1,ts)  + 1;
           end
        end
        if Asso_UE_true_norea(u, ts) == 0
           unasso_true_norea(1,ts) = unasso_true_norea(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_true_norea(u, 1, ts) ~= Asso_UE_true_norea(idx_u, 1, ts-1) && Asso_UE_true_norea(idx_u, 1, ts-1)~= 0
              hover_true_norea(1,ts)  = hover_true_norea(1,ts)  + 1;
           end
        end        
    end
end
MUE_min = zeros(1,T_last/60);
hover_true_min = zeros(1,T_last/60);
hover_true_womin_min = zeros(1,T_last/60);
hover_true_norea_min = zeros(1,T_last/60);
hover_ori_min = zeros(1,T_last/60);
unasso_true_min = zeros(1,T_last/60);
unasso_ori_min = zeros(1,T_last/60);
unasso_true_womin_min = zeros(1,T_last/60);
unasso_true_norea_min = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        MUE_min(1,t) = MUE_min(1,t) + N_UE_guess(1,(t-1)*60+u);
        hover_true_min(1,t) = hover_true_min(1,t) + hover_true(1,(t-1)*60+u);
        hover_true_womin_min(1,t) = hover_true_womin_min(1,t) + hover_true_womin(1,(t-1)*60+u);
        hover_true_norea_min(1,t) = hover_true_norea_min(1,t) + hover_true_norea(1,(t-1)*60+u);
        hover_ori_min(1,t) = hover_ori_min(1,t) + hover_ori(1,(t-1)*60+u);
        unasso_true_min(1,t) = unasso_true_min(1,t) + unasso_true(1,(t-1)*60+u);
        unasso_true_womin_min(1,t) = unasso_true_womin_min(1,t) + unasso_true_womin(1,(t-1)*60+u);
        unasso_true_norea_min(1,t) = unasso_true_norea_min(1,t) + unasso_true_norea(1,(t-1)*60+u);
        unasso_ori_min(1,t) = unasso_ori_min(1,t) + unasso_ori(1,(t-1)*60+u);
    end
end

X = 1:T_last/60;
figure(61)
yyaxis left
plot(X,hover_true_min./MUE_min*100,'g',X,unasso_true_min./MUE_min*100,'b',X,hover_ori_min./MUE_min*100,'r-',X,unasso_ori_min./MUE_min*100,'y-');
ylabel('service outage rate(%)');
title(['service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2)']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

yyaxis right
plot(X,MUE_min./60,'k');
ylabel('number of UE');
ylim([0 inf]);
legend('outage by handover', 'outage by de-association','outage by handover(before)','outage by de-association(before)','number of UE');
str = {['average service outage(handover) = ' num2str(sum(hover_true_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(handover(before)) = ' num2str(sum(hover_ori_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(de-association) = ' num2str(sum(unasso_true_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(de-association(before)) = ' num2str(sum(unasso_ori_min,2)/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');
X = 1:T_last/60;

figure(62)
overall_otrate = hover_true_min+unasso_true_min-hover_ori_min;
plot(X,(hover_true_min+unasso_true_min-hover_ori_min)./MUE_min*100,'g');
ylabel('service outage rate(%)');
title(['overall service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2)']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);
str_2 = {['average service outage(complete algorithm) = ' num2str(sum(hover_true_min+unasso_true_min-hover_ori_min,2)/sum(N_UE_record,2)*100) ' % ']};
annotation('textbox','String',str_2,'FitBoxToText','on');

figure(63)
wei_unasso = 1;
%plot(X,(hover_true_min+unasso_true_min)./MUE_min*100,'g',X,(hover_true_norea_min+unasso_true_norea_min)./MUE_min*100,'m',X,(hover_true_womin_min+unasso_true_womin_min)./MUE_min*100,'r',X,(hover_ori_min+unasso_ori_min)./MUE_min*100,'b');
plot(X,(hover_true_min+unasso_true_min)./MUE_min*100,'g',X,(hover_true_norea_min+unasso_true_norea_min)./MUE_min*100,'m',X,(hover_true_womin_min+unasso_true_womin_min)./MUE_min*100,'r');
ylabel('service outage rate(%)');
title(['service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2) with de-association weight = 1']);
ylim([0 inf]);
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);
legend('overall outage by complete algorithm', 'overall outage without reassociation', 'overall outage without BS min-power','overall outage without reassociation and BS min-power');
str_2 = {['average service outage(complete algorithm) = ' num2str(sum(hover_true_min+unasso_true_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(without reassociation with BS min-power) = ' num2str(sum(hover_true_norea_min+unasso_true_norea_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(without BS min-power with reassociation) = ' num2str(sum(hover_true_womin_min+unasso_true_womin_min,2)/sum(N_UE_record,2)*100) ' % '] };
       %['average service outage(without reassociation with BS min-power) = ' num2str(sum(hover_ori_min+unasso_ori_min,2)/sum(N_UE_record,2)*100) ' % '] };
annotation('textbox','String',str_2,'FitBoxToText','on');

%% unasso & handover & without_ho(need to load data without handover and store handover data in Asso_UE_true_w_ho first)
unasso_true = zeros(1,T_last);
unasso_ori = zeros(1,T_last);
hover_true = zeros(1,T_last);
hover_ori = zeros(1,T_last);   %Asso_UE_record
hover_true_w_ho = zeros(1,T_last);
for  ts = 2:T_last
    for u = 1:N_UE_guess(1,ts)
        preassoflag = ID_Asso_UE_record(u,1,ts) == ID_Asso_UE_record(:,1,ts-1);
        idx_u = find(preassoflag);
        if Asso_UE_true(u, ts) == 0
           unasso_true(1,ts) = unasso_true(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_true(u, 1, ts) ~= Asso_UE_true(idx_u, 1, ts-1) && Asso_UE_true(idx_u, 1, ts-1)~= 0
              hover_true(1,ts)  = hover_true(1,ts)  + 1;
           end
        end
        if Asso_UE_true_norea(u, ts) == 0
           unasso_ori(1,ts) = unasso_ori(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_true_norea(u, 1, ts) ~= Asso_UE_true_norea(idx_u, 1, ts-1) && Asso_UE_true_norea(idx_u, 1, ts-1)~= 0
              hover_ori(1,ts)  = hover_ori(1,ts)  + 1;
           end
        end
        if Asso_UE_true_w_ho(u, ts) == 0
           unasso_ori(1,ts) = unasso_ori(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_true_w_ho(u, 1, ts) ~= Asso_UE_true_w_ho(idx_u, 1, ts-1) && Asso_UE_true_w_ho(idx_u, 1, ts-1)~= 0
              hover_true_w_ho(1,ts)  = hover_true_w_ho(1,ts)  + 1;
           end
        end        
    end
end
MUE_min = zeros(1,T_last/60);
hover_true_min = zeros(1,T_last/60);
hover_ori_min = zeros(1,T_last/60);
unasso_true_min = zeros(1,T_last/60);
unasso_ori_min = zeros(1,T_last/60);
hover_true_w_ho_min = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        MUE_min(1,t) = MUE_min(1,t) + N_UE_guess(1,(t-1)*60+u);
        hover_true_min(1,t) = hover_true_min(1,t) + hover_true(1,(t-1)*60+u);
        hover_true_w_ho_min(1,t) = hover_true_w_ho_min(1,t) + hover_true_w_ho(1,(t-1)*60+u);
        unasso_true_min(1,t) = unasso_true_min(1,t) + unasso_true(1,(t-1)*60+u);
        hover_ori_min(1,t) = hover_ori_min(1,t) + hover_ori(1,(t-1)*60+u);
        unasso_ori_min(1,t) = unasso_ori_min(1,t) + unasso_ori(1,(t-1)*60+u);
    end
end

X = 1:T_last/60;
figure(61)
yyaxis left
%plot(X,hover_true_min./MUE_min*100,'g',X,unasso_true_min./MUE_min*100,'b',X,hover_ori_min./MUE_min*100,'r-',X,unasso_ori_min./MUE_min*100,'y-',X,hover_true_w_ho./MUE_min*100,'m');
plot(X,hover_true_min./MUE_min*100,'r',X,hover_true_w_ho_min./MUE_min*100,'g'); %, , X,unasso_true_min./MUE_min*100,'b'
ylabel('service outage rate(%)');
title(['service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2)']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

yyaxis right
plot(X,MUE_min./60,'k');
ylabel('number of UE');
ylim([0 inf]);
%legend('outage by handover', 'outage by de-association','outage by handover(original)','outage by de-association(original)','number of UE');
legend('outage by handover', 'outage by handover machanism'); %'outage by de-association','number of UE'

       %['average service outage(ori. handover) = ' num2str(sum(hover_ori_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       %['average service outage(de-association) = ' num2str(sum(unasso_ori_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
str = {['average service outage(handover) = ' num2str(sum(hover_true_min,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(handover with machanism ) = ' num2str(sum(hover_true_w_ho_min,2)/sum(N_UE_record,2)*100) ' % '] };%,...
       %['average service outage(ori. de-association) = ' num2str(sum(unasso_true_min,2)/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');


%% unasso algorithm comparison



unasso_guessf = zeros(1,T_last/60);
unasso_guess_noreasso = zeros(1,T_last/60);
unasso_guess_womin = zeros(1,T_last/60);
unasso_true = zeros(1,T_last/60);
unasso_true_womin = zeros(1,T_last/60);
unasso_true_noreasso = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        unasso_guessf(1,t)         = unasso_guessf(1,t)         + sum(Asso_UE_guess_final_wm(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_guess_noreasso(1,t) = unasso_guess_noreasso(1,t) + sum(Asso_UE_guess_final_norea(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_guess_womin(1,t)    = unasso_guess_womin(1,t)    + sum(Asso_UE_guess_final_womin(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_true(1,t)           = unasso_true(1,t)           + sum(Asso_UE_true(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_true_womin(1,t)     = unasso_true_womin(1,t)     + sum(Asso_UE_true_womin(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_true_noreasso(1,t)  = unasso_true_noreasso(1,t)  + sum(Asso_UE_true_norea(1:N_UE_guess(1,(t-1)*60+u),(t-1)*60+u)==0,1);
    end
end


MUE_min = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        MUE_min(1,t) = MUE_min(1,t) + N_UE_guess(1,(t-1)*60+u);
    end
end

figure(51);
X = 1:T_last/60;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
% plot(X,unasso_guessf./60,'r',X,unasso_guess./60,'g',X,unasso_true./60,'b');
% legend('by predicted solar data','by predicted solar data before use true solar data calibration', 'by true solar data');

plot(X,unasso_guessf./MUE_min*100,'g',X,unasso_guess_noreasso./MUE_min*100,'r',X,unasso_guess_womin./MUE_min*100,'k',X,unasso_true./MUE_min*100,'b');
legend('by predicted solar data','by predicted solar data with out reassociation','by predicted solar data without BS power minimization', 'by true solar data');
ylabel('service outage rate(%)');
title(['service outage rate']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

% yyaxis right
% plot(X,MUE_min./60,'m');
% ylabel('number of UE');
% ylim([0 inf]);

str = {['average service outage(predicted solar) = ' num2str(sum(unasso_guessf,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(predicted solar without reassociation) = ' num2str(sum(unasso_guess_noreasso,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(predicted solar without power minimization) = ' num2str(sum(unasso_guess_womin,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(known solar) = ' num2str(sum(unasso_true,2)/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');

figure(52);
X = 1:T_last/60;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
% plot(X,unasso_guessf./60,'r',X,unasso_guess./60,'g',X,unasso_true./60,'b');
% legend('by predicted solar data','by predicted solar data before use true solar data calibration', 'by true solar data');

plot(X,unasso_true_noreasso./MUE_min*100,'r',X,unasso_true_womin./MUE_min*100,'k',X,unasso_true./MUE_min*100,'b');
legend('with out reassociation','without BS power minimization', 'by true solar data');
ylabel('service outage rate(%)');
title(['service outage rate']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

% yyaxis right
% plot(X,MUE_min./60,'m');
% ylabel('number of UE');
% ylim([0 inf]);

str = {['average service outage(without reassociation) = ' num2str(sum(unasso_true_noreasso,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(without power minimization) = ' num2str(sum(unasso_true_womin,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(complete algorithm) = ' num2str(sum(unasso_true,2)/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');
title('preformance under true solar data');

figure(53);
X = 1:T_last/60;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
% plot(X,unasso_guessf./60,'r',X,unasso_guess./60,'g',X,unasso_true./60,'b');
% legend('by predicted solar data','by predicted solar data before use true solar data calibration', 'by true solar data');

plot(X,unasso_true_womin./MUE_min*100,'g',X,unasso_true./MUE_min*100,'b');
legend('without BS power minimization', 'by true solar data');
ylabel('service outage rate(%)');
title(['service outage rate']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

% yyaxis right
% plot(X,MUE_min./60,'m');
% ylabel('number of UE');
% ylim([0 inf]);

str = {['average service outage(without power minimization) = ' num2str(sum(unasso_true_womin,2)/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(complete algorithm) = ' num2str(sum(unasso_true,2)/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');
title('preformance under true solar data');

%% plot xmit rate:
Location_BS = [0, 0];
UE_List = [1, 10, 0.1, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 1, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 10, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 20, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 50, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 100, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 120, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 150, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 200, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 250, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 300, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 350, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 400, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 450, 0 ,10,10,0.1, 0.1, 0;...
1, 10, 500, 0 ,10,10,0.1, 0.1, 0];

UE_Xmitpower = 23;                                                         %dbm
BS_Xmitpower = 30;
km = 1000;
BW = 12*(15e3); 
Noise = -174+10*log10(BW) ;
Fc = 1.7;     %Ghz
[UE_XULrate ,UE_XDLrate,UE_BS_distance]= SINR_calc(UE_List,Location_BS,UE_Xmitpower,BS_Xmitpower,Noise,km,BW,Fc);
UE_XULrate = UE_XULrate./8./1024;
UE_XDLrate = UE_XDLrate./8./1024;

subplot(2,1,1);
plot(UE_List(:,3),UE_XULrate(:,1));
ylabel('KB/s');
title(['Uplink transmission rate per resource block for Small basestation']);
xlabel('distance(m)');

subplot(2,1,2);
plot(UE_List(:,3),UE_XDLrate(:,1));
ylabel('KB/s');
title(['Downlink transmission rate per resource block for Small basestation']);
xlabel('distance(m)');