%% plot: energy(guess with reasso, minpower) , solar(guess,Wmin),solar(true,Wmin)
%initialize
EnergyCom_BS                   = EnergyCom_BS_guess_final_wm ;
solar_BS_1s_1day_target        = solar_BS_1s_1day_guess;
solar_BS_1s_1day_true          = solar_BS_1s_1day_guess;

Min_EnergyCom_BS = zeros(N_BS,T_last/60);
Min_solar_BS_1s_1day = zeros(N_BS,T_last/60);
Min_solar_BS_1s_1day_t = zeros(N_BS,T_last/60);
for i = 1:T_last/60
    for u = 1:60
        Min_EnergyCom_BS(:,i) = Min_EnergyCom_BS(:,i)+EnergyCom_BS(:,(i-1)*60+u);
        Min_solar_BS_1s_1day(:,i) = Min_solar_BS_1s_1day(:,i) + solar_BS_1s_1day_target(:,(i-1)*60+u);
        Min_solar_BS_1s_1day_t(:,i) = Min_solar_BS_1s_1day_t(:,i) + solar_BS_1s_1day_true(:,(i-1)*60+u);
    end
    
end

K =2;
X = 1:T_last/60;
%yyaxis left
%X = 1:T_last
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
plot(X,Min_EnergyCom_BS(K,:)./60,'b',X,Min_solar_BS_1s_1day(K,:)./60,'r',X, Min_solar_BS_1s_1day_t(K,:)./60,'g');
legend('Small cell energy consumption','solar power prediction','true solar power data');
ylabel('W');
title(['Small basestation ' num2str(K)]);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);



%% plot adjust_power_ratio(guess) AND original power ratio 

Min_solar_BS_1s_1day = zeros(N_BS,1440);
Min_Allocate_solar_BS_1day_f = zeros(N_BS,T_last/60);
Min_Allocate_solar_BS_1day = zeros(N_BS,T_last/60);
Min_EnergyCom_BS = zeros(N_BS,T_last/60);
Min_EnergyCom_BS_f = zeros(N_BS,T_last/60);
Min_EnergyCom_BS_afreasso= zeros(N_BS,T_last/60);
for i = 1:T_last/60
    for u = 1:60
        Min_solar_BS_1s_1day(:,i)          = Min_solar_BS_1s_1day(:,i)        +  solar_BS_1s_1day_guess(:,(i-1)*60+u);
        Min_EnergyCom_BS(:,i)              = Min_EnergyCom_BS(:,i)            +  EnergyCom_BS_prereasso(:,(i-1)*60+u);
        Min_EnergyCom_BS_afreasso(:,i)     = Min_EnergyCom_BS_afreasso(:,i)   +  EnergyCom_BS_guess(:,(i-1)*60+u);
        Min_Allocate_solar_BS_1day(:,i)    = Min_Allocate_solar_BS_1day(:,i)  +  Allocate_solar_BS_1day_guess(:,(i-1)*60+u);
        Min_Allocate_solar_BS_1day_f(:,i)  = Min_Allocate_solar_BS_1day_f(:,i)+  Allocate_solar_BS_1day_final_wm(:,(i-1)*60+u);
        Min_EnergyCom_BS_f(:,i)            = Min_EnergyCom_BS_f(:,i)          +  EnergyCom_BS_guess_final_wm(:,(i-1)*60+u);
    end
end
Min_adjust_power_ratio = Min_Allocate_solar_BS_1day./Min_EnergyCom_BS;
Min_adjust_power_ratio_f = Min_Allocate_solar_BS_1day_f./Min_EnergyCom_BS_f;

X = 1:T_last/60;
K = 4;
plot(X,Min_solar_BS_1s_1day(K,:)./Min_EnergyCom_BS(K,:),'b',X,Min_adjust_power_ratio(K,:),'g',X,Min_adjust_power_ratio_f(K,:),'r',X,Min_Allocate_solar_BS_1day(K,:)./Min_EnergyCom_BS_afreasso(K,:),'y');%X,Min_EnergyCom_BS(K,:)./Min_solar_BS_1s_1day(K,:),'b'
ylabel('ratio');
title(['Power ratio(solar/consume) Small basestation ' num2str(K)]);
ylim([0 inf]);
xlabel('TIME');
xticks([1 7200/60:7200/60:T_last/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);
legend( 'power ratio before adjusted','power ratio adjusted(balancing) by guessed solar','power ratio adjusted(balancing+reassociation) by guessed solar','power ratio after applying true solar data');


%% Just solar
%solar
%solar_EBU_1day = Mesa2(72929:72929+86400-1);
Min_solar_BS_1s_1day = zeros(N_BS,1440);
Min_solar_BS_1s_1day_t = zeros(N_BS,1440);
for i = 1:1440
    for u = 1:60
        Min_solar_BS_1s_1day(:,i)   = Min_solar_BS_1s_1day(:,i)+solar_BS_1s_1day_guess(:,(i-1)*60+u);
        Min_solar_BS_1s_1day_t(:,i) = Min_solar_BS_1s_1day_t(:,i)+solar_BS_1s_1day_true(:,(i-1)*60+u);
    end
    
end

K =2;
X = 1:1440;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
plot(X,Min_solar_BS_1s_1day(K,:)./60,'g',X,Min_solar_BS_1s_1day_t(K,:)./60,'b');
legend('predicted solar data','true solar data');
ylabel('W');
title(['Small basestation ' num2str(K)]);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:86400/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 86400/60]);


%% unasso and N_UE
% unasso_pre = zeros(1,T_last/60);
% for t = 1:T_last/60
%     for u = 1:60
%         unasso_pre(1,t) = unasso_pre(1,t) + sum(Asso_UE_record_pre(1:N_UE_record(1,(t-1)*60+u),(t-1)*60+u)==0,1);
%     end
% end
% 
% unasso_afterbal = zeros(1,T_last/60);
% for t = 1:T_last/60
%     for u = 1:60
%         unasso_afterbal(1,t) = unasso_afterbal(1,t) + sum(Asso_UE_record_afterbal(1:N_UE_record(1,(t-1)*60+u),(t-1)*60+u)==0,1);
%     end
% end


unasso_guessf = zeros(1,T_last/60);
unasso_guess = zeros(1,T_last/60);
unasso_true = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        unasso_guessf(1,t) = unasso_guessf(1,t) + sum(Asso_UE_guess_final(1:N_UE_record(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_guess(1,t) = unasso_guess(1,t) + sum(Asso_UE_guess(1:N_UE_record(1,(t-1)*60+u),(t-1)*60+u)==0,1);
        unasso_true(1,t) = unasso_true(1,t) + sum(Asso_UE_true(1:N_UE_record(1,(t-1)*60+u),(t-1)*60+u)==0,1);
    end
end


MUE_min = zeros(1,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        MUE_min(1,t) = MUE_min(1,t) + N_UE_guess(1,(t-1)*60+u);
    end
end


K =3;
X = 1:T_last/60;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
% plot(X,unasso_guessf./60,'r',X,unasso_guess./60,'g',X,unasso_true./60,'b');
% legend('by predicted solar data','by predicted solar data before use true solar data calibration', 'by true solar data');
figure(50+K);
plot(X,unasso_guessf./MUE_min,'g',X,unasso_true./MUE_min,'b');
legend('by predicted solar data', 'by true solar data');
ylabel('service outage rate(%)');
title(['service outage rate']);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60]);
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'});
xlim([0 T_last/60]);

str = {['average service outage(predicted solar) = ' num2str(sum(unasso_guessf,2)/T_last/sum(N_UE_record,2)*100) ' % '] ,...
       ['average service outage(known solar) = ' num2str(sum(unasso_true,2)/T_last/sum(N_UE_record,2)*100) ' % '] ;};
annotation('textbox','String',str,'FitBoxToText','on');
%% battery
battery_min = zeros(N_BS,T_last/60);
for t = 1:T_last/60
    for u = 1:60
        battery_min(:,t) = battery_min(:,t) + battery_record(:,(t-1)*60+u);
    end
end

for k = 1:6

K =k;
X = 1:T_last/60;
%yyaxis left
%X = 1:86400
%plot(X,EnergyCom_UE2BS(K,:),'b',X,EnergyCom_BS(K,:),'y',X,solar_BS_1s_1day(K,:),'r');
figure(k);
plot(X,battery_min(K,:)./60,'r');
legend('battery level(J)');
%plot(X,unasso_guess./60,'g',X,unasso_true./60,'b');
%legend('by predicted solar data before use true solar data calibration', 'by true solar data');
ylabel('J: averag in one minute');
title(['battery level - Small basestation ' num2str(K)]);
ylim([0 inf]);
%yyaxis right;
%plot(X,Asso_needed);
%ylim([0 inf]);
%ylabel('#');
%legend('number of associated user');
xlabel('TIME');
%xticks([1 7200:7200:86400])
xticks([1 7200/60:7200/60:T_last/60])
xticklabels({'12PM','14','16','18','20','22','0AM','2','4','6','8','10','12PM'})
xlim([0 T_last/60]);
str = ['max battery level = ' num2str(max(battery_min(K,:),[],2)/60/3600) ' (Whr)'];
annotation('textbox','String',str,'FitBoxToText','on');
end