%set handover weight here
%kappa_weight = 0.1;

%set what data you want to compare here
target_asso_alg = Asso_UE_record_true_alg;%Asso_UE_record_pred_alg;%Asso_UE_true_alg_2 %Asso_UE_record_pred2_MR
target_asso_alg_2 = Asso_UE_record_pred2_MR4;%Asso_UE_record_nores_alg;%Asso_UE_record_true_alg
target_asso_alg_3 = Asso_UE_RC1;
%kappa_weight_temp = 0.1;
kappa_weight_temp = kappa_weight;
strlgd = ['alg1:predict + GAP algorm';'alg2: precious algorithm '];

timeperslot = ( 60/t_granu )*10; %10min, (60/t_granu) is the data point for each minute
unasso_alg = zeros(1,T_last/t_granu);
hover_alg = zeros(1,T_last/t_granu);
unasso_alg_2 = zeros(1,T_last/t_granu);
hover_alg_2 = zeros(1,T_last/t_granu);
unasso_alg_3 = zeros(1,T_last/t_granu);
hover_alg_3 = zeros(1,T_last/t_granu);
hover_nan     = zeros(1,T_last/t_granu);
unasso_nan = zeros(1,T_last/t_granu);
for  ts = 2:T_last/t_granu
    for u = 1:N_UE_record(1,ts)
        preassoflag = ID_Asso_UE_record(u,1,ts) == ID_Asso_UE_record(:,1,ts-1);
        idx_u = find(preassoflag);
        if target_asso_alg(u, ts) == 0
           unasso_alg(1,ts) = unasso_alg(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if target_asso_alg(u, 1, ts) ~= target_asso_alg(idx_u, 1, ts-1) && target_asso_alg(idx_u, 1, ts-1)~= 0
              hover_alg(1,ts)  = hover_alg(1,ts)  + 1;
           end
        end
        if Asso_UE_record(u, ts) == 0
           unasso_nan(1,ts) = unasso_nan(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if Asso_UE_record(u, 1, ts) ~= Asso_UE_record(idx_u, 1, ts-1) && Asso_UE_record(idx_u, 1, ts-1)~= 0
              hover_nan(1,ts)  = hover_nan(1,ts)  + 1;
           end
        end
        if target_asso_alg_2(u, ts) == 0
           unasso_alg_2(1,ts) = unasso_alg_2(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if target_asso_alg_2(u, 1, ts) ~= target_asso_alg_2(idx_u, 1, ts-1) && target_asso_alg_2(idx_u, 1, ts-1)~= 0
              hover_alg_2(1,ts)  = hover_alg_2(1,ts)  + 1;
           end
        end
        if target_asso_alg_3(u, ts) == 0
           unasso_alg_3(1,ts) = unasso_alg_3(1,ts) + 1; 
        elseif ~isempty(idx_u)
           if target_asso_alg_3(u, 1, ts) ~= target_asso_alg_3(idx_u, 1, ts-1) && target_asso_alg_3(idx_u, 1, ts-1)~= 0
              hover_alg_3(1,ts)  = hover_alg_3(1,ts)  + 1;
           end
        end
    end
end
cost_hov_alg_10min  = zeros(1,T_last/t_granu/timeperslot);
cost_una_alg_10min  = zeros(1,T_last/t_granu/timeperslot);
cost_hov_alg2_10min  = zeros(1,T_last/t_granu/timeperslot);
cost_una_alg2_10min  = zeros(1,T_last/t_granu/timeperslot);
cost_hov_alg3_10min  = zeros(1,T_last/t_granu/timeperslot);
cost_una_alg3_10min  = zeros(1,T_last/t_granu/timeperslot);
hover_nan_10min = zeros(1,T_last/t_granu/timeperslot);
N_UE_10min = zeros(1,T_last/t_granu/timeperslot);
EnergyCom_BS_min_10min  = zeros(1,T_last/t_granu/timeperslot);

for ts = 1:T_last/t_granu/timeperslot
    for u = 1:timeperslot
        cost_hov_alg_10min(1,ts)  = cost_hov_alg_10min(1,ts) + hover_alg(1,(ts-1)*timeperslot + u);
        cost_una_alg_10min(1,ts)  = cost_una_alg_10min(1,ts) + unasso_alg(1,(ts-1)*timeperslot + u);
        cost_hov_alg2_10min(1,ts)  = cost_hov_alg2_10min(1,ts) + hover_alg_2(1,(ts-1)*timeperslot + u);
        cost_una_alg2_10min(1,ts)  = cost_una_alg2_10min(1,ts) + unasso_alg_2(1,(ts-1)*timeperslot + u);
        cost_hov_alg3_10min(1,ts)  = cost_hov_alg3_10min(1,ts) + hover_alg_3(1,(ts-1)*timeperslot + u);
        cost_una_alg3_10min(1,ts)  = cost_una_alg3_10min(1,ts) + unasso_alg_3(1,(ts-1)*timeperslot + u);
       
        %cost_mtd_10min(1,ts)  = cost_mtd_10min(1,ts) + hover_method1(1,(ts-1)*60*10 + u) + unasso_method1(1,(ts-1)*60*10 + u);
        %cost_mtd2_10min(1,ts) = cost_mtd2_10min(1,ts) + hover_method2(1,(ts-1)*60*10 + u) + unasso_method2(1,(ts-1)*60*10 + u);   
        N_UE_10min(1,ts) = N_UE_10min(1,ts) +  N_UE_record(1,(ts-1)*timeperslot + u);
        hover_nan_10min(1,ts) = hover_nan_10min(1,ts) + hover_nan(1,(ts-1)*timeperslot + u); 
        EnergyCom_BS_min_10min(1,ts) = EnergyCom_BS_min_10min(1,ts) + EnergyCom_BS_min(1,(ts-1)*timeperslot + u);
    end
end
cost_alg_10min = cost_hov_alg_10min*kappa_weight+cost_una_alg_10min;
cost_alg2_10min = cost_hov_alg2_10min*kappa_weight+cost_una_alg2_10min;
cost_alg3_10min = cost_hov_alg3_10min*kappa_weight_temp+cost_una_alg3_10min;
X_10min = 1:T_last/t_granu/timeperslot;

figure(4)
yyaxis left
plot(X_10min,( cost_alg_10min)./N_UE_10min*100,'b-d',X_10min,( cost_alg2_10min)./N_UE_10min*100,'r-*',X_10min,( cost_alg3_10min)./N_UE_10min*100,'g-*' );
ylabel('service outage rate(%)');
title(['service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2) (before handover calibration)']);
xlabel('TIME');
xticks([1 7200/t_granu/timeperslot:7200/t_granu/timeperslot:T_last/t_granu/timeperslot]);
xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
xlim([0 T_last/t_granu/timeperslot]);
ax = gca;
ax.YColor = 'b';
yyaxis right
plot(X_10min,N_UE_10min./t_granu./timeperslot,'k-.');
ylabel('number of user');
legend('outage by using alg1','outage by alg2', 'number of user');
str = {['average (alg1) = ' num2str(sum(cost_alg_10min,2)*100/sum(N_UE_10min,2)) ' % '];...
       ['average (alg2) = ' num2str(sum(cost_alg2_10min,2)*100/sum(N_UE_10min,2)) ' % ']};
annotation('textbox','String',str,'FitBoxToText','on');
annotation('textbox','String',strlgd,'FitBoxToText','on');
ax = gca;
ax.YColor = 'k'; 


% figure(5)
% yyaxis left
% plot(X_10min,( cost_alg_10min-hover_nan_10min*kappa_weight)./N_UE_10min*100,'b-d',X_10min,( cost_alg2_10min-hover_nan_10min*kappa_weight)./N_UE_10min*100,'r-*');
% ylabel('service outage rate(%)');
% title(['service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2)']);
% xlabel('TIME');
% xticks([1 7200/t_granu/timeperslot:7200/t_granu/timeperslot:T_last/t_granu/timeperslot]);
% xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
% xlim([0 T_last/t_granu/timeperslot]);
% ax = gca;
% ax.YColor = 'b';
% 
% yyaxis right
% plot(X_10min,N_UE_10min./timeperslot,'k-.');
% ylabel('number of user');
% legend('outage by using actual solar data','outage by 2.5 min sample solar prediction', 'number of user');
% str = {['average service outage(actual solar data) = ' num2str(sum(cost_alg_10min-hover_nan_10min*kappa_weight,2)*100/sum(N_UE_10min,2)) ' % '];...
%        ['average service outage(2.5 min sample solar prediction) = ' num2str(sum(cost_alg2_10min-hover_nan_10min*kappa_weight,2)*100/sum(N_UE_10min,2)) ' % ']};
% 
% annotation('textbox','String',str,'FitBoxToText','on');
% ax = gca;
% ax.YColor = 'k';

figure(6) %shows only handover
yyaxis left
plot(X_10min,( cost_hov_alg_10min)./N_UE_10min*100,'b-d',X_10min,( cost_hov_alg2_10min)./N_UE_10min*100,'r-*' );
ylabel('handover rate(%)');
title(['handover rate']);
xlabel('TIME');
xticks([1 7200/t_granu/timeperslot:7200/t_granu/timeperslot:T_last/t_granu/timeperslot]);
xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
xlim([0 T_last/t_granu/timeperslot]);
ax = gca;
ax.YColor = 'b';
yyaxis right
plot(X_10min,N_UE_10min./t_granu./timeperslot,'k-.');
ylabel('number of user');
legend('handover rate of alg1','handover rate of alg2', 'number of user');
str = {['average(blue) = ' num2str(sum(cost_hov_alg_10min,2)*100/sum(N_UE_10min,2)) ' % '];...
       ['average(red) = ' num2str(sum(cost_hov_alg2_10min,2)*100/sum(N_UE_10min,2)) ' % ']};
annotation('textbox','String',str,'FitBoxToText','on');
annotation('textbox','String',strlgd,'FitBoxToText','on');
ax = gca;
ax.YColor = 'k';

figure(7) %shows only outage
yyaxis left
plot(X_10min,( cost_una_alg_10min)./N_UE_10min*100,'b-d',X_10min,( cost_una_alg2_10min)./N_UE_10min*100,'r-*' );
ylabel('drop rate(%)');
title(['drop rate']);
xlabel('TIME');
xticks([1 7200/timeperslot:7200/timeperslot:T_last/timeperslot]);
xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
xlim([0 T_last/t_granu/timeperslot]);
ax = gca;
ax.YColor = 'b';
yyaxis right
plot(X_10min,N_UE_10min./timeperslot,'k-.');
ylabel('number of user');
legend('drop rate of alg1','drop rate of alg2', 'number of user');
str = {['average(blue) = ' num2str(sum(cost_una_alg_10min,2)*100/sum(N_UE_10min,2)) ' % '];...
       ['average(red) = ' num2str(sum(cost_una_alg2_10min,2)*100/sum(N_UE_10min,2)) ' % ']};
annotation('textbox','String',str,'FitBoxToText','on');
annotation('textbox','String',strlgd,'FitBoxToText','on');
ax = gca;
ax.YColor = 'k';


figure(8)
plot(X_10min,( cost_alg_10min)./N_UE_10min*100,'r-d',X_10min,( cost_alg2_10min)./N_UE_10min*100,'b-*',X_10min,( cost_alg3_10min)./N_UE_10min*100,'g-*' );
ylabel('service outage rate(%)');
title(['service outage rate with solar panel size = ' num2str(Panelsize/1.3)  '(m^2)']);
xlabel('TIME');
xticks([1 7200/t_granu/timeperslot:7200/t_granu/timeperslot:T_last/t_granu/timeperslot]);
xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
xlim([0 T_last/t_granu/timeperslot]);
legend('outage by using QLM','outage by new algorithm', 'outage by GAURA');

figure(9) %shows only handover
plot(X_10min,( cost_hov_alg_10min)./N_UE_10min*100,'r-d',X_10min,( cost_hov_alg2_10min)./N_UE_10min*100,'b-*',X_10min,( cost_hov_alg3_10min)./N_UE_10min*100,'g-*' );
ylabel('handover rate(%)');
title(['handover rate']);
xlabel('TIME');
xticks([1 7200/t_granu/timeperslot:7200/t_granu/timeperslot:T_last/t_granu/timeperslot]);
xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
xlim([0 T_last/t_granu/timeperslot]);
%ax = gca;
%ax.YColor = 'b';
%yyaxis right
%plot(X_10min,N_UE_10min./t_granu./timeperslot,'k-.');
%ylabel('number of user');
legend('handover rate of QLM','handover rate of new algorithm', 'handover rate of GAURA');

figure(10) %shows only outage
plot(X_10min,( cost_una_alg_10min)./N_UE_10min*100,'r-d',X_10min,( cost_una_alg2_10min)./N_UE_10min*100,'b-*',X_10min,( cost_una_alg3_10min)./N_UE_10min*100,'g-*'  );
ylabel('drop rate(%)');
title(['drop rate']);
xlabel('TIME');
xticks([1 7200/t_granu/timeperslot:7200/t_granu/timeperslot:T_last/t_granu/timeperslot]);
xticklabels({'9AM','11','13','15','17','19','21','23','1AM','3','5','7','9AM'});
xlim([0 T_last/t_granu/timeperslot]);
%ax = gca;
%ax.YColor = 'b';
%yyaxis right
%plot(X_10min,N_UE_10min./timeperslot,'k-.');
%ylabel('number of user');
legend('drop rate of QLM','drop rate of new algorithm', 'drop rate of GAURA');
