function [Com_needed_min, UE_comneed_min, Asso] = minpower_w_limComRB_func(UE_List, Asso,UE_XDLrate)
%1: Lane, 2: Velocity(m/s), 3:X, 4:Y, 5: 10MB/s for uploading, 6:10MIPS, 7:0.1MB/s downloading 8:delay requirement: 0.1s 9:video downloading size(<1/3: only alarm message, 1/3<&&<2/3: 720p video, >2/3: 1080p video   10: UE_ID)
global debug_variable_1
global debug_variable_2
global debug_variable_3
global debug_variable_4
[N_UE,N_BS] = size(UE_XDLrate);
global Comp_fullW;
global ca;
global DL_avalRB;
global P_d_RB;

%UE_ListAssoAB = zeros(N_BS, 1); %1: Asso, 2:a_i(allocated com) 3:b_i(allocated DLRB)
Com_needed_min = zeros(N_BS,1);
UE_comneed_min = zeros(N_UE,1);

   for ibs = 1:N_BS
    stop_flag = 0;
    while ~stop_flag
        aflag = Asso(:,1)==ibs;
        Idx_ue = find(aflag);
        temp_UE_List = UE_List(aflag,:);
        TN_UE = size(temp_UE_List,1);
        temp_UErate = UE_XDLrate(aflag,:);
        gan = temp_UE_List(:,7)./temp_UErate(:,ibs)./temp_UE_List(:,8);
        sig = gan.*temp_UE_List(:,6)./temp_UE_List(:,8);
        b_i_DLstream = sum(  ceil(temp_UE_List(:,9)./temp_UErate(:,ibs)), 1  );
      if b_i_DLstream >= DL_avalRB-TN_UE || DL_avalRB-TN_UE-b_i_DLstream-sum(gan,1)<=0
         [~, idx_dlxbi] = max( temp_UE_List(:,9)./temp_UErate(:,ibs) + gan,[],1);
         Asso( Idx_ue(idx_dlxbi,1),1 )= 0;
      else
        
      

          Q_t = sum(sqrt(sig),1)/(DL_avalRB-TN_UE-b_i_DLstream-sum(gan,1));
          y_i = sqrt(temp_UE_List(:,6))./temp_UE_List(:,8)+sqrt(gan./temp_UE_List(:,8)).*Q_t;
          
          if Q_t <= 0 && ~isempty(temp_UE_List)
             warning('Q_t less than or equals 0');
             UE_List
             debug_variable_1 = temp_UE_List;
             gan
             debug_variable_2 = temp_UErate;
             sig
             debug_variable_3 = TN_UE;
             disp(['Q_t = ' num2str(Q_t)]);
             pause;
          end
          
          a_i = ceil(y_i.*sqrt(temp_UE_List(:,6)));
          b_i = ceil(y_i.*sqrt(gan.*temp_UE_List(:,8))./Q_t);
                 
          a_i = a_i';
          b_i = b_i'; 
          if  sum(b_i,2) + b_i_DLstream > DL_avalRB 
             warning('downlink resource block exceed maximum');
             pause;
          elseif abs(sum(b_i,2) + b_i_DLstream - DL_avalRB) > TN_UE && ~isempty(temp_UE_List)
             warning('downlink resource block is not fully utilized');
             sum(b_i,2)
             b_i_DLstream
             b_i
             TN_UE
             ibs
             debug_variable_1 = temp_UE_List;
             debug_variable_2 = temp_UErate;
             debug_variable_3 = b_i;
             debug_variable_4 = a_i;
             pause;
          end

       if sum( a_i < 0 ,2)~=0 
          warning('a_i < 0');
          pause;
       end
       if sum( b_i < 0 ,2)~=0 
          warning('b_i < 0');
          pause;
       end
       SUMA = sum(a_i,2);
       
       if SUMA > ca 
             DLE = (temp_UE_List(:,7)./temp_UErate(:,ibs) + ceil(temp_UE_List(:,9)./temp_UErate(:,ibs)) );    
             CME = Comp_fullW/ca.*a_i';
             if ~isequal(size(DLE), size(CME))
                warning('matrix size is does not match'); 
             end
             [~, idx_maxai] = max(  P_d_RB*DLE + CME  ,[],1 );
             Asso( Idx_ue(idx_maxai,1),1 )= 0;         
       else
          stop_flag = 1; %use a_i #1 
       end
       
       

      end%end if: check DL stream is supported
    end
      if sum(b_i+ceil(temp_UE_List(:,9)'./temp_UErate(:,ibs)'),2) > DL_avalRB
        warning('wrong kkt conditon calculation: RB limit violated');   
        pause;
      end
      if sum(a_i,2) >ca
        warning('wrong kkt conditon calculation: com limit violated');     
        pause;
      end
      if sum( a_i < 0 ,2)~=0 
          warning('a_i < 0');
          stop;
       end
       if sum( b_i < 0 ,2)~=0 
          warning('b_i < 0');
          stop;
       end
      for ue = 1:TN_UE
          chv =  temp_UE_List(ue,6)/a_i(1,ue) + temp_UE_List(ue,7)/temp_UErate(ue,ibs)/b_i(1,ue) ;
           if chv > temp_UE_List(ue,8)
              warning('wrong kkt conditon calculation: delay constrant violated'); 
              warning([ 'Math: ' num2str(temp_UE_List(ue,6)) ' / ' num2str(a_i(1,ue)) ' + ' num2str(temp_UE_List(ue,7)) ' / ' num2str(temp_UErate(ue,ibs)) ' / ' num2str(b_i(1,ue)) ' = ' num2str(chv) ' > ' num2str(temp_UE_List(ue,8))]); 
           end
           UE_comneed_min(ue,1) = a_i(1,ue);
      end
      Com_needed_min(ibs,1)=sum(a_i,2);
   end
end


