function [ Allocate_solar_BS_1day, flag] = solar_1cell_balancing_greedy_2(solar_BS_1s_1day,EnergyCom_BS)
global N_BS;
global t_granu;
T_Last = size(solar_BS_1s_1day,2);
flag = 1;
posi = 0;
battery = zeros(N_BS,1);
Allocate_solar_BS_1day= zeros(N_BS,T_Last);

for ts = 1:T_Last
       for b = 1:N_BS   
          if battery(b,1) > 50*3600/t_granu
             posi = 1;
             Allocate_solar_BS_1day(b,ts) = 1.2*EnergyCom_BS(b,ts);  
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts) - 1.2*EnergyCom_BS(b,ts);
          elseif solar_BS_1s_1day(b,ts) > EnergyCom_BS(b,ts)
             posi = 2;
             Allocate_solar_BS_1day(b,ts) = EnergyCom_BS(b,ts);  
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts) - EnergyCom_BS(b,ts);             
          elseif battery(b,1) + solar_BS_1s_1day(b,ts) > EnergyCom_BS(b,ts)
             posi = 3;
             Allocate_solar_BS_1day(b,ts) = EnergyCom_BS(b,ts);  
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts) - EnergyCom_BS(b,ts); 
          else 
             posi = 4;
             Allocate_solar_BS_1day(b,ts) = 0;
             battery(b,1) =  battery(b,1) + solar_BS_1s_1day(b,ts);
          end
           if  battery(b,1) < 1e-9
              warning('battery<0');
              battery(b,1)
              ts
              posi
              flag = 0;
              pause;
           end
       end
end




end