U = sym('u', [1 2]);
V = sym('v', [1 2]);

eqns = [2*U(1,1)^2 + V(1,1)^2 == 0, U(1,1) - V(1,1) == 1,2*U(1,2)^2 + 2*V(1,2)^2 == 0, U(1,2) + V(1,2) == 1];
vars = [U,V];
S = solve(eqns, vars);

ibs = 1;
aflag = asso(:,1)==ibs;
temp_UElist = UE_List(aflag,:);
TN_UE = size(temp_UE_List,1);
temp_UErate = UE_XDLrate(aflag,:);
A = sym('a', [1 TN_UE]);
B = sym('b', [1 TN_UE]);
K = sym('k', [1 TN_UE]);
syms v1 v2
eqns = [v1*(sum(A(1,:))-ca)==0, v2*(sum(B(1,:))-DL_avalRB)==0  ];
for ue = 1:TN_UE
    eqns = [ eqns, 2*Comp_fullW/Ca*sum(A(1,:)) - K(1,ue)*temp_UE_List(ue,6)/A(1,ue)^2+v1==0 ];
    eqns = [ eqns, DL_fullW/fullRB - K(1,ue)*temp_UE_List(ue,7)/UE_XDLrate(ue,asso(ue,1))/8/1024^2/B(1,ue)^2+v2==0];
    eqns = [ eqns, K(1,ue)*(temp_UE_List(ue,6)/A(1,ue)+temp_UE_List(ue,7)/temp_UErate(ue,ibs)/8/1024^2/B(1,ue)-temp_UE_List(ue,8))==0];
end
vars = [A,B,K,v1,v2];   
S = solve(eqns, vars);

